/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         CISAparse
#define yylex           CISAlex
#define yyerror         CISAerror
#define yydebug         CISAdebug
#define yynerrs         CISAnerrs
#define yylval          CISAlval
#define yychar          CISAchar

/* First part of user prologue.  */
#line 9 "CISA.y"

#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>

#include "visa_igc_common_header.h"
#include "Common_ISA.h"
#include "Common_ISA_util.h"
#include "Common_ISA_framework.h"
#include "JitterDataStruct.h"
#include "VISAKernel.h"

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size);

void CISAerror(CISA_IR_Builder* builder, char const* msg);
int yylex(CISA_IR_Builder *pBuilder);
extern int CISAlineno;

static bool streq(const char *sym0, const char *sym1);
static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value);
static VISA_Align AlignBytesToVisaAlignment(int bytes);
static int DataTypeSizeOf(VISA_Type type);
static bool ParseEMask(const char* sym, VISA_EMask_Ctrl &emask);

//
// check if the cond is true.
// if cond is false, then print errorMessage (syntax error) and YYABORT
#define MUST_HOLD(cond, errorMessage) \
  {if (!(cond)) {pBuilder->RecordParseError(CISAlineno, errorMessage); YYABORT;}}
#define PARSE_ERROR_AT(LINE,...)\
  {pBuilder->RecordParseError(LINE, __VA_ARGS__); YYABORT;}
#define PARSE_ERROR(...)\
    PARSE_ERROR_AT(CISAlineno, __VA_ARGS__)

// Use this to wrap API calls that return false, nullptr, or 0 on failure
// It's assumed that the API call reported the parse error
#define ABORT_ON_FAIL(X) \
    do \
        if (!(X)) \
            YYABORT;\
    while (0)
#define TRACE(S) \
    do { \
      if (CISAout && pBuilder->debugParse()) \
          fprintf(CISAout, "line %d: %s", CISAlineno, S); \
    } while (0)

std::deque<const char*> switchLabels;
std::vector<VISA_opnd*> RTRWOperandsVec;

VISA_RawOpnd* rawOperandArray[16];

// global var for non-kernel attribute option.
// The var needs to be cleared before each use.
std::vector<attr_gen_struct*> AttrOptVar;


#line 142 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "CISA.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ALIGN_KEYWORD = 3,              /* ALIGN_KEYWORD  */
  YYSYMBOL_ATOMIC_SUB_OP = 4,              /* ATOMIC_SUB_OP  */
  YYSYMBOL_DIRECTIVE_DECL = 5,             /* DIRECTIVE_DECL  */
  YYSYMBOL_DIRECTIVE_FUNC = 6,             /* DIRECTIVE_FUNC  */
  YYSYMBOL_DIRECTIVE_FUNCDECL = 7,         /* DIRECTIVE_FUNCDECL  */
  YYSYMBOL_DIRECTIVE_GLOBAL_FUNC = 8,      /* DIRECTIVE_GLOBAL_FUNC  */
  YYSYMBOL_DIRECTIVE_IMPLICIT = 9,         /* DIRECTIVE_IMPLICIT  */
  YYSYMBOL_DIRECTIVE_INPUT = 10,           /* DIRECTIVE_INPUT  */
  YYSYMBOL_DIRECTIVE_KERNEL = 11,          /* DIRECTIVE_KERNEL  */
  YYSYMBOL_DIRECTIVE_KERNEL_ATTR = 12,     /* DIRECTIVE_KERNEL_ATTR  */
  YYSYMBOL_DIRECTIVE_VERSION = 13,         /* DIRECTIVE_VERSION  */
  YYSYMBOL_ALIAS_EQ = 14,                  /* ALIAS_EQ  */
  YYSYMBOL_ALIGN_EQ = 15,                  /* ALIGN_EQ  */
  YYSYMBOL_ATTR_EQ = 16,                   /* ATTR_EQ  */
  YYSYMBOL_OFFSET_EQ = 17,                 /* OFFSET_EQ  */
  YYSYMBOL_NUM_ELTS_EQ = 18,               /* NUM_ELTS_EQ  */
  YYSYMBOL_V_NAME_EQ = 19,                 /* V_NAME_EQ  */
  YYSYMBOL_SIZE_EQ = 20,                   /* SIZE_EQ  */
  YYSYMBOL_V_TYPE_EQ_G = 21,               /* V_TYPE_EQ_G  */
  YYSYMBOL_V_TYPE_EQ_P = 22,               /* V_TYPE_EQ_P  */
  YYSYMBOL_V_TYPE_EQ_A = 23,               /* V_TYPE_EQ_A  */
  YYSYMBOL_V_TYPE_EQ_S = 24,               /* V_TYPE_EQ_S  */
  YYSYMBOL_V_TYPE_EQ_T = 25,               /* V_TYPE_EQ_T  */
  YYSYMBOL_CPS = 26,                       /* CPS  */
  YYSYMBOL_NON_UNIFORM_SAMPLER = 27,       /* NON_UNIFORM_SAMPLER  */
  YYSYMBOL_PIXEL_NULL_MASK = 28,           /* PIXEL_NULL_MASK  */
  YYSYMBOL_RAW_SEND_STRING = 29,           /* RAW_SEND_STRING  */
  YYSYMBOL_RAW_SENDC_STRING = 30,          /* RAW_SENDC_STRING  */
  YYSYMBOL_RAW_SENDS_STRING = 31,          /* RAW_SENDS_STRING  */
  YYSYMBOL_RAW_SENDS_EOT_STRING = 32,      /* RAW_SENDS_EOT_STRING  */
  YYSYMBOL_RAW_SENDSC_STRING = 33,         /* RAW_SENDSC_STRING  */
  YYSYMBOL_RAW_SENDSC_EOT_STRING = 34,     /* RAW_SENDSC_EOT_STRING  */
  YYSYMBOL_SAT = 35,                       /* SAT  */
  YYSYMBOL_SRCMOD_ABS = 36,                /* SRCMOD_ABS  */
  YYSYMBOL_SRCMOD_NEG = 37,                /* SRCMOD_NEG  */
  YYSYMBOL_SRCMOD_NEGABS = 38,             /* SRCMOD_NEGABS  */
  YYSYMBOL_SRCMOD_NOT = 39,                /* SRCMOD_NOT  */
  YYSYMBOL_BFN_OP = 40,                    /* BFN_OP  */
  YYSYMBOL_DPAS_OP = 41,                   /* DPAS_OP  */
  YYSYMBOL_SVM_ALIGNED = 42,               /* SVM_ALIGNED  */
  YYSYMBOL_SVM_UNALIGNED = 43,             /* SVM_UNALIGNED  */
  YYSYMBOL_NBARRIER_SIGNAL = 44,           /* NBARRIER_SIGNAL  */
  YYSYMBOL_NBARRIER_WAIT = 45,             /* NBARRIER_WAIT  */
  YYSYMBOL_ITYPE = 46,                     /* ITYPE  */
  YYSYMBOL_DECL_DATA_TYPE = 47,            /* DECL_DATA_TYPE  */
  YYSYMBOL_DFTYPE = 48,                    /* DFTYPE  */
  YYSYMBOL_FTYPE = 49,                     /* FTYPE  */
  YYSYMBOL_HFTYPE = 50,                    /* HFTYPE  */
  YYSYMBOL_BFTYPE = 51,                    /* BFTYPE  */
  YYSYMBOL_VTYPE = 52,                     /* VTYPE  */
  YYSYMBOL_COND_MOD = 53,                  /* COND_MOD  */
  YYSYMBOL_LANGLE = 54,                    /* LANGLE  */
  YYSYMBOL_RANGLE = 55,                    /* RANGLE  */
  YYSYMBOL_LBRACK = 56,                    /* LBRACK  */
  YYSYMBOL_RBRACK = 57,                    /* RBRACK  */
  YYSYMBOL_IND_LBRACK = 58,                /* IND_LBRACK  */
  YYSYMBOL_LPAREN = 59,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 60,                    /* RPAREN  */
  YYSYMBOL_LBRACE = 61,                    /* LBRACE  */
  YYSYMBOL_RBRACE = 62,                    /* RBRACE  */
  YYSYMBOL_DOT = 63,                       /* DOT  */
  YYSYMBOL_COMMA = 64,                     /* COMMA  */
  YYSYMBOL_SEMI = 65,                      /* SEMI  */
  YYSYMBOL_COLON = 66,                     /* COLON  */
  YYSYMBOL_SLASH = 67,                     /* SLASH  */
  YYSYMBOL_PERCENT = 68,                   /* PERCENT  */
  YYSYMBOL_EQUALS = 69,                    /* EQUALS  */
  YYSYMBOL_PLUS = 70,                      /* PLUS  */
  YYSYMBOL_MINUS = 71,                     /* MINUS  */
  YYSYMBOL_TIMES = 72,                     /* TIMES  */
  YYSYMBOL_AMP = 73,                       /* AMP  */
  YYSYMBOL_CIRC = 74,                      /* CIRC  */
  YYSYMBOL_PIPE = 75,                      /* PIPE  */
  YYSYMBOL_TILDE = 76,                     /* TILDE  */
  YYSYMBOL_BANG = 77,                      /* BANG  */
  YYSYMBOL_QUESTION = 78,                  /* QUESTION  */
  YYSYMBOL_LEQ = 79,                       /* LEQ  */
  YYSYMBOL_GEQ = 80,                       /* GEQ  */
  YYSYMBOL_EQ = 81,                        /* EQ  */
  YYSYMBOL_NEQ = 82,                       /* NEQ  */
  YYSYMBOL_SHL = 83,                       /* SHL  */
  YYSYMBOL_SHRS = 84,                      /* SHRS  */
  YYSYMBOL_SHRZ = 85,                      /* SHRZ  */
  YYSYMBOL_LABEL = 86,                     /* LABEL  */
  YYSYMBOL_IDENT = 87,                     /* IDENT  */
  YYSYMBOL_BUILTIN_NULL = 88,              /* BUILTIN_NULL  */
  YYSYMBOL_BUILTIN = 89,                   /* BUILTIN  */
  YYSYMBOL_STRING_LIT = 90,                /* STRING_LIT  */
  YYSYMBOL_NEWLINE = 91,                   /* NEWLINE  */
  YYSYMBOL_BUILD_OPTION_LINE = 92,         /* BUILD_OPTION_LINE  */
  YYSYMBOL_UNIFORM = 93,                   /* UNIFORM  */
  YYSYMBOL_RTWRITE_OPTION = 94,            /* RTWRITE_OPTION  */
  YYSYMBOL_MEDIA_MODE = 95,                /* MEDIA_MODE  */
  YYSYMBOL_OWORD_MODIFIER = 96,            /* OWORD_MODIFIER  */
  YYSYMBOL_SAMPLER_CHANNEL = 97,           /* SAMPLER_CHANNEL  */
  YYSYMBOL_CHANNEL_OUTPUT = 98,            /* CHANNEL_OUTPUT  */
  YYSYMBOL_EXECMODE = 99,                  /* EXECMODE  */
  YYSYMBOL_CNTRL = 100,                    /* CNTRL  */
  YYSYMBOL_FENCE_OPTIONS = 101,            /* FENCE_OPTIONS  */
  YYSYMBOL_ADDR_ADD_OP = 102,              /* ADDR_ADD_OP  */
  YYSYMBOL_UNARY_LOGIC_OP = 103,           /* UNARY_LOGIC_OP  */
  YYSYMBOL_BINARY_LOGIC_OP = 104,          /* BINARY_LOGIC_OP  */
  YYSYMBOL_TERNARY_LOGIC_OP = 105,         /* TERNARY_LOGIC_OP  */
  YYSYMBOL_QUATERNARY_LOGIC_OP = 106,      /* QUATERNARY_LOGIC_OP  */
  YYSYMBOL_SEL_OP = 107,                   /* SEL_OP  */
  YYSYMBOL_MIN_OP = 108,                   /* MIN_OP  */
  YYSYMBOL_MAX_OP = 109,                   /* MAX_OP  */
  YYSYMBOL_ANTI_TRIG_OP = 110,             /* ANTI_TRIG_OP  */
  YYSYMBOL_MATH2_OP = 111,                 /* MATH2_OP  */
  YYSYMBOL_MATH3_OP = 112,                 /* MATH3_OP  */
  YYSYMBOL_ARITH2_OP = 113,                /* ARITH2_OP  */
  YYSYMBOL_ARITH3_OP = 114,                /* ARITH3_OP  */
  YYSYMBOL_ARITH4_OP = 115,                /* ARITH4_OP  */
  YYSYMBOL_ARITH4_OP2 = 116,               /* ARITH4_OP2  */
  YYSYMBOL_ARITH5_OP2 = 117,               /* ARITH5_OP2  */
  YYSYMBOL_CMP_OP = 118,                   /* CMP_OP  */
  YYSYMBOL_SVM_OP = 119,                   /* SVM_OP  */
  YYSYMBOL_SVM_SCATTER_OP = 120,           /* SVM_SCATTER_OP  */
  YYSYMBOL_SVM_GATHER4SCALED_OP = 121,     /* SVM_GATHER4SCALED_OP  */
  YYSYMBOL_SVM_SCATTER4SCALED_OP = 122,    /* SVM_SCATTER4SCALED_OP  */
  YYSYMBOL_SVM_ATOMIC_OP = 123,            /* SVM_ATOMIC_OP  */
  YYSYMBOL_OWORD_OP = 124,                 /* OWORD_OP  */
  YYSYMBOL_MEDIA_OP = 125,                 /* MEDIA_OP  */
  YYSYMBOL_SCATTER_OP = 126,               /* SCATTER_OP  */
  YYSYMBOL_SCATTER_TYPED_OP = 127,         /* SCATTER_TYPED_OP  */
  YYSYMBOL_SCATTER_SCALED_OP = 128,        /* SCATTER_SCALED_OP  */
  YYSYMBOL_SCATTER4_SCALED_OP = 129,       /* SCATTER4_SCALED_OP  */
  YYSYMBOL_BARRIER_OP = 130,               /* BARRIER_OP  */
  YYSYMBOL_SBARRIER_SIGNAL = 131,          /* SBARRIER_SIGNAL  */
  YYSYMBOL_SBARRIER_WAIT = 132,            /* SBARRIER_WAIT  */
  YYSYMBOL_DWORD_ATOMIC_OP = 133,          /* DWORD_ATOMIC_OP  */
  YYSYMBOL_TYPED_ATOMIC_OP = 134,          /* TYPED_ATOMIC_OP  */
  YYSYMBOL_SAMPLE_OP = 135,                /* SAMPLE_OP  */
  YYSYMBOL_SAMPLE_UNORM_OP = 136,          /* SAMPLE_UNORM_OP  */
  YYSYMBOL_VME_IME_OP = 137,               /* VME_IME_OP  */
  YYSYMBOL_VME_SIC_OP = 138,               /* VME_SIC_OP  */
  YYSYMBOL_VME_FBR_OP = 139,               /* VME_FBR_OP  */
  YYSYMBOL_BRANCH_OP = 140,                /* BRANCH_OP  */
  YYSYMBOL_RET_OP = 141,                   /* RET_OP  */
  YYSYMBOL_IFCALL = 142,                   /* IFCALL  */
  YYSYMBOL_FCALL = 143,                    /* FCALL  */
  YYSYMBOL_FADDR = 144,                    /* FADDR  */
  YYSYMBOL_SWITCHJMP_OP = 145,             /* SWITCHJMP_OP  */
  YYSYMBOL_MOVS_OP = 146,                  /* MOVS_OP  */
  YYSYMBOL_SETP_OP = 147,                  /* SETP_OP  */
  YYSYMBOL_MOV_OP = 148,                   /* MOV_OP  */
  YYSYMBOL_FILE_OP = 149,                  /* FILE_OP  */
  YYSYMBOL_LOC_OP = 150,                   /* LOC_OP  */
  YYSYMBOL_CACHE_FLUSH_OP = 151,           /* CACHE_FLUSH_OP  */
  YYSYMBOL_WAIT_OP = 152,                  /* WAIT_OP  */
  YYSYMBOL_FENCE_GLOBAL_OP = 153,          /* FENCE_GLOBAL_OP  */
  YYSYMBOL_FENCE_LOCAL_OP = 154,           /* FENCE_LOCAL_OP  */
  YYSYMBOL_FENCE_SW_OP = 155,              /* FENCE_SW_OP  */
  YYSYMBOL_YIELD_OP = 156,                 /* YIELD_OP  */
  YYSYMBOL_SAMPLE_3D_OP = 157,             /* SAMPLE_3D_OP  */
  YYSYMBOL_LOAD_3D_OP = 158,               /* LOAD_3D_OP  */
  YYSYMBOL_SAMPLE4_3D_OP = 159,            /* SAMPLE4_3D_OP  */
  YYSYMBOL_RESINFO_OP_3D = 160,            /* RESINFO_OP_3D  */
  YYSYMBOL_SAMPLEINFO_OP_3D = 161,         /* SAMPLEINFO_OP_3D  */
  YYSYMBOL_RTWRITE_OP_3D = 162,            /* RTWRITE_OP_3D  */
  YYSYMBOL_URBWRITE_OP_3D = 163,           /* URBWRITE_OP_3D  */
  YYSYMBOL_LIFETIME_START_OP = 164,        /* LIFETIME_START_OP  */
  YYSYMBOL_LIFETIME_END_OP = 165,          /* LIFETIME_END_OP  */
  YYSYMBOL_AVS_OP = 166,                   /* AVS_OP  */
  YYSYMBOL_BREAKPOINT_OP = 167,            /* BREAKPOINT_OP  */
  YYSYMBOL_CALL_OP = 168,                  /* CALL_OP  */
  YYSYMBOL_PRED_CNTL = 169,                /* PRED_CNTL  */
  YYSYMBOL_F32_LIT = 170,                  /* F32_LIT  */
  YYSYMBOL_F64_LIT = 171,                  /* F64_LIT  */
  YYSYMBOL_DEC_LIT = 172,                  /* DEC_LIT  */
  YYSYMBOL_HEX_LIT = 173,                  /* HEX_LIT  */
  YYSYMBOL_BUILTIN_SIZEOF = 174,           /* BUILTIN_SIZEOF  */
  YYSYMBOL_BUILTIN_DISPATCH_SIMD_SIZE = 175, /* BUILTIN_DISPATCH_SIMD_SIZE  */
  YYSYMBOL_QW_SCATTER_OP = 176,            /* QW_SCATTER_OP  */
  YYSYMBOL_LSC_CACHING_OPT = 177,          /* LSC_CACHING_OPT  */
  YYSYMBOL_LSC_ADDR_SIZE_TK = 178,         /* LSC_ADDR_SIZE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK = 179,        /* LSC_DATA_SHAPE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_CHMASK = 180, /* LSC_DATA_SHAPE_TK_CHMASK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_BLOCK2D = 181, /* LSC_DATA_SHAPE_TK_BLOCK2D  */
  YYSYMBOL_LSC_AM_FLAT = 182,              /* LSC_AM_FLAT  */
  YYSYMBOL_LSC_AM_BTI = 183,               /* LSC_AM_BTI  */
  YYSYMBOL_LSC_AM_BSS = 184,               /* LSC_AM_BSS  */
  YYSYMBOL_LSC_AM_SS = 185,                /* LSC_AM_SS  */
  YYSYMBOL_LSC_AM_ARG = 186,               /* LSC_AM_ARG  */
  YYSYMBOL_LSC_FENCE_OP_TYPE = 187,        /* LSC_FENCE_OP_TYPE  */
  YYSYMBOL_LSC_FENCE_SCOPE = 188,          /* LSC_FENCE_SCOPE  */
  YYSYMBOL_LSC_SFID_UNTYPED_TOKEN = 189,   /* LSC_SFID_UNTYPED_TOKEN  */
  YYSYMBOL_LSC_SFID_TYPED_TOKEN = 190,     /* LSC_SFID_TYPED_TOKEN  */
  YYSYMBOL_LSC_LOAD_MNEMONIC = 191,        /* LSC_LOAD_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_STRIDED_MNEMONIC = 192, /* LSC_LOAD_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_BLOCK2D_MNEMONIC = 193, /* LSC_LOAD_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_STORE_MNEMONIC = 194,       /* LSC_STORE_MNEMONIC  */
  YYSYMBOL_LSC_STORE_STRIDED_MNEMONIC = 195, /* LSC_STORE_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_STORE_BLOCK2D_MNEMONIC = 196, /* LSC_STORE_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_ATOMIC_MNEMONIC = 197,      /* LSC_ATOMIC_MNEMONIC  */
  YYSYMBOL_LSC_READ_STATE_INFO_MNEMONIC = 198, /* LSC_READ_STATE_INFO_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_MSRT_MNEMONIC = 199,   /* LSC_LOAD_MSRT_MNEMONIC  */
  YYSYMBOL_LSC_STORE_MSRT_MNEMONIC = 200,  /* LSC_STORE_MSRT_MNEMONIC  */
  YYSYMBOL_LSC_FENCE_MNEMONIC = 201,       /* LSC_FENCE_MNEMONIC  */
  YYSYMBOL_FCVT_OP = 202,                  /* FCVT_OP  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_TYPED_BLOCK2D = 203, /* LSC_DATA_SHAPE_TK_TYPED_BLOCK2D  */
  YYSYMBOL_YYACCEPT = 204,                 /* $accept  */
  YYSYMBOL_Listing = 205,                  /* Listing  */
  YYSYMBOL_ListingHeader = 206,            /* ListingHeader  */
  YYSYMBOL_Statements = 207,               /* Statements  */
  YYSYMBOL_Newlines = 208,                 /* Newlines  */
  YYSYMBOL_NewlinesOpt = 209,              /* NewlinesOpt  */
  YYSYMBOL_Statement = 210,                /* Statement  */
  YYSYMBOL_Scope = 211,                    /* Scope  */
  YYSYMBOL_ScopeStart = 212,               /* ScopeStart  */
  YYSYMBOL_ScopeEnd = 213,                 /* ScopeEnd  */
  YYSYMBOL_IdentOrStringLit = 214,         /* IdentOrStringLit  */
  YYSYMBOL_DirectiveKernel = 215,          /* DirectiveKernel  */
  YYSYMBOL_DirectiveGlobalFunction = 216,  /* DirectiveGlobalFunction  */
  YYSYMBOL_DirectiveVersion = 217,         /* DirectiveVersion  */
  YYSYMBOL_DirectiveDecl = 218,            /* DirectiveDecl  */
  YYSYMBOL_DeclFunction = 219,             /* DeclFunction  */
  YYSYMBOL_DeclVariable = 220,             /* DeclVariable  */
  YYSYMBOL_DeclAddress = 221,              /* DeclAddress  */
  YYSYMBOL_DeclPredicate = 222,            /* DeclPredicate  */
  YYSYMBOL_DeclSampler = 223,              /* DeclSampler  */
  YYSYMBOL_VNameEqOpt = 224,               /* VNameEqOpt  */
  YYSYMBOL_DeclSurface = 225,              /* DeclSurface  */
  YYSYMBOL_DirectiveInput = 226,           /* DirectiveInput  */
  YYSYMBOL_DirectiveImplicitInput = 227,   /* DirectiveImplicitInput  */
  YYSYMBOL_InputOffset = 228,              /* InputOffset  */
  YYSYMBOL_InputSize = 229,                /* InputSize  */
  YYSYMBOL_DirectiveAttr = 230,            /* DirectiveAttr  */
  YYSYMBOL_DirectiveFunc = 231,            /* DirectiveFunc  */
  YYSYMBOL_AlignAttrOpt = 232,             /* AlignAttrOpt  */
  YYSYMBOL_Align = 233,                    /* Align  */
  YYSYMBOL_AliasAttrOpt = 234,             /* AliasAttrOpt  */
  YYSYMBOL_OneAttr = 235,                  /* OneAttr  */
  YYSYMBOL_AttrOpt = 236,                  /* AttrOpt  */
  YYSYMBOL_GenAttrOpt = 237,               /* GenAttrOpt  */
  YYSYMBOL_Instruction = 238,              /* Instruction  */
  YYSYMBOL_Label = 239,                    /* Label  */
  YYSYMBOL_LogicInstruction = 240,         /* LogicInstruction  */
  YYSYMBOL_UnaryLogicInstruction = 241,    /* UnaryLogicInstruction  */
  YYSYMBOL_MathInstruction_2OPND = 242,    /* MathInstruction_2OPND  */
  YYSYMBOL_MathInstruction_3OPND = 243,    /* MathInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_2OPND = 244,   /* ArithInstruction_2OPND  */
  YYSYMBOL_ArithInstruction_3OPND = 245,   /* ArithInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_4OPND = 246,   /* ArithInstruction_4OPND  */
  YYSYMBOL_DpasInstruction = 247,          /* DpasInstruction  */
  YYSYMBOL_BfnInstruction = 248,           /* BfnInstruction  */
  YYSYMBOL_QwScatterInstruction = 249,     /* QwScatterInstruction  */
  YYSYMBOL_FCvtInstruction = 250,          /* FCvtInstruction  */
  YYSYMBOL_AntiTrigInstruction = 251,      /* AntiTrigInstruction  */
  YYSYMBOL_AddrAddInstruction = 252,       /* AddrAddInstruction  */
  YYSYMBOL_SetpInstruction = 253,          /* SetpInstruction  */
  YYSYMBOL_SelInstruction = 254,           /* SelInstruction  */
  YYSYMBOL_MinInstruction = 255,           /* MinInstruction  */
  YYSYMBOL_MaxInstruction = 256,           /* MaxInstruction  */
  YYSYMBOL_MovInstruction = 257,           /* MovInstruction  */
  YYSYMBOL_BreakpointInstruction = 258,    /* BreakpointInstruction  */
  YYSYMBOL_MovsInstruction = 259,          /* MovsInstruction  */
  YYSYMBOL_CmpInstruction = 260,           /* CmpInstruction  */
  YYSYMBOL_MediaInstruction = 261,         /* MediaInstruction  */
  YYSYMBOL_MediaInstructionPlaneID = 262,  /* MediaInstructionPlaneID  */
  YYSYMBOL_ScatterInstruction = 263,       /* ScatterInstruction  */
  YYSYMBOL_ScatterTypedInstruction = 264,  /* ScatterTypedInstruction  */
  YYSYMBOL_Scatter4ScaledInstruction = 265, /* Scatter4ScaledInstruction  */
  YYSYMBOL_ScatterScaledInstruction = 266, /* ScatterScaledInstruction  */
  YYSYMBOL_SynchronizationInstruction = 267, /* SynchronizationInstruction  */
  YYSYMBOL_DwordAtomicInstruction = 268,   /* DwordAtomicInstruction  */
  YYSYMBOL_TypedAtomicInstruction = 269,   /* TypedAtomicInstruction  */
  YYSYMBOL_Atomic16Opt = 270,              /* Atomic16Opt  */
  YYSYMBOL_SampleUnormInstruction = 271,   /* SampleUnormInstruction  */
  YYSYMBOL_SampleInstruction = 272,        /* SampleInstruction  */
  YYSYMBOL_SamplerAddrOperand = 273,       /* SamplerAddrOperand  */
  YYSYMBOL_Sample3dInstruction = 274,      /* Sample3dInstruction  */
  YYSYMBOL_CPSEnableOpt = 275,             /* CPSEnableOpt  */
  YYSYMBOL_NonUniformSamplerEnableOpt = 276, /* NonUniformSamplerEnableOpt  */
  YYSYMBOL_Load3dInstruction = 277,        /* Load3dInstruction  */
  YYSYMBOL_Gather43dInstruction = 278,     /* Gather43dInstruction  */
  YYSYMBOL_PixelNullMaskEnableOpt = 279,   /* PixelNullMaskEnableOpt  */
  YYSYMBOL_ResInfo3dInstruction = 280,     /* ResInfo3dInstruction  */
  YYSYMBOL_SampleInfo3dInstruction = 281,  /* SampleInfo3dInstruction  */
  YYSYMBOL_RTWriteOperands = 282,          /* RTWriteOperands  */
  YYSYMBOL_RTWriteInstruction = 283,       /* RTWriteInstruction  */
  YYSYMBOL_RTWriteModeOpt = 284,           /* RTWriteModeOpt  */
  YYSYMBOL_URBWriteInstruction = 285,      /* URBWriteInstruction  */
  YYSYMBOL_AVSInstruction = 286,           /* AVSInstruction  */
  YYSYMBOL_VMEInstruction = 287,           /* VMEInstruction  */
  YYSYMBOL_OwordInstruction = 288,         /* OwordInstruction  */
  YYSYMBOL_SvmInstruction = 289,           /* SvmInstruction  */
  YYSYMBOL_AtomicBitwidthOpt = 290,        /* AtomicBitwidthOpt  */
  YYSYMBOL_LscInstruction = 291,           /* LscInstruction  */
  YYSYMBOL_LscUntypedLoad = 292,           /* LscUntypedLoad  */
  YYSYMBOL_LscUntypedStridedLoad = 293,    /* LscUntypedStridedLoad  */
  YYSYMBOL_LscUntypedBlock2dLoad = 294,    /* LscUntypedBlock2dLoad  */
  YYSYMBOL_LscUntypedStore = 295,          /* LscUntypedStore  */
  YYSYMBOL_LscUntypedStridedStore = 296,   /* LscUntypedStridedStore  */
  YYSYMBOL_LscUntypedBlock2dStore = 297,   /* LscUntypedBlock2dStore  */
  YYSYMBOL_LscUntypedAtomic = 298,         /* LscUntypedAtomic  */
  YYSYMBOL_LscTypedMSRTLoad = 299,         /* LscTypedMSRTLoad  */
  YYSYMBOL_LscTypedMSRTStore = 300,        /* LscTypedMSRTStore  */
  YYSYMBOL_LscTypedLoad = 301,             /* LscTypedLoad  */
  YYSYMBOL_LscTypedStore = 302,            /* LscTypedStore  */
  YYSYMBOL_LscTypedAtomic = 303,           /* LscTypedAtomic  */
  YYSYMBOL_LscTypedReadStateInfo = 304,    /* LscTypedReadStateInfo  */
  YYSYMBOL_LscFence = 305,                 /* LscFence  */
  YYSYMBOL_LscSfid = 306,                  /* LscSfid  */
  YYSYMBOL_LscCacheOpts = 307,             /* LscCacheOpts  */
  YYSYMBOL_LscUntypedAddrOperand = 308,    /* LscUntypedAddrOperand  */
  YYSYMBOL_LscUntypedStridedAddrOperand = 309, /* LscUntypedStridedAddrOperand  */
  YYSYMBOL_LscUntypedBlock2dAddrOperand = 310, /* LscUntypedBlock2dAddrOperand  */
  YYSYMBOL_LscTypedAddrWithOffsetOperand = 311, /* LscTypedAddrWithOffsetOperand  */
  YYSYMBOL_LscTypedAddrWithOffsetOperandList = 312, /* LscTypedAddrWithOffsetOperandList  */
  YYSYMBOL_LscTypedAddrOperandWithOffsets = 313, /* LscTypedAddrOperandWithOffsets  */
  YYSYMBOL_LscAddrImmOffsetOpt = 314,      /* LscAddrImmOffsetOpt  */
  YYSYMBOL_LscAddrImmScaleOpt = 315,       /* LscAddrImmScaleOpt  */
  YYSYMBOL_LscAddrModelOpt = 316,          /* LscAddrModelOpt  */
  YYSYMBOL_LscAddrModelStateful = 317,     /* LscAddrModelStateful  */
  YYSYMBOL_LscVectorOpRegOrImm32 = 318,    /* LscVectorOpRegOrImm32  */
  YYSYMBOL_LscVectorOpImm32 = 319,         /* LscVectorOpImm32  */
  YYSYMBOL_LscVectorOpReg = 320,           /* LscVectorOpReg  */
  YYSYMBOL_LscDataOperand = 321,           /* LscDataOperand  */
  YYSYMBOL_LscDataOperand2D = 322,         /* LscDataOperand2D  */
  YYSYMBOL_LscPayloadReg = 323,            /* LscPayloadReg  */
  YYSYMBOL_LscPayloadNonNullReg = 324,     /* LscPayloadNonNullReg  */
  YYSYMBOL_LscInstructionXe2 = 325,        /* LscInstructionXe2  */
  YYSYMBOL_LscTypedBlock2dLoad = 326,      /* LscTypedBlock2dLoad  */
  YYSYMBOL_LscTypedBlock2dStore = 327,     /* LscTypedBlock2dStore  */
  YYSYMBOL_LscTypedBlock2dAddrOperand = 328, /* LscTypedBlock2dAddrOperand  */
  YYSYMBOL_LscDataOperandTyped2D = 329,    /* LscDataOperandTyped2D  */
  YYSYMBOL_LscUntypedApndCtrAtomic = 330,  /* LscUntypedApndCtrAtomic  */
  YYSYMBOL_SwitchLabels = 331,             /* SwitchLabels  */
  YYSYMBOL_BranchInstruction = 332,        /* BranchInstruction  */
  YYSYMBOL_FILE = 333,                     /* FILE  */
  YYSYMBOL_LOC = 334,                      /* LOC  */
  YYSYMBOL_RawSendInstruction = 335,       /* RawSendInstruction  */
  YYSYMBOL_LifetimeStartInst = 336,        /* LifetimeStartInst  */
  YYSYMBOL_LifetimeEndInst = 337,          /* LifetimeEndInst  */
  YYSYMBOL_RawSendsInstruction = 338,      /* RawSendsInstruction  */
  YYSYMBOL_NullaryInstruction = 339,       /* NullaryInstruction  */
  YYSYMBOL_OwordModifier = 340,            /* OwordModifier  */
  YYSYMBOL_Predicate = 341,                /* Predicate  */
  YYSYMBOL_PredSign = 342,                 /* PredSign  */
  YYSYMBOL_PredCtrlOpt = 343,              /* PredCtrlOpt  */
  YYSYMBOL_SatModOpt = 344,                /* SatModOpt  */
  YYSYMBOL_SrcModifier = 345,              /* SrcModifier  */
  YYSYMBOL_ConditionalModifier = 346,      /* ConditionalModifier  */
  YYSYMBOL_VecDstOperand_A = 347,          /* VecDstOperand_A  */
  YYSYMBOL_VecDstOperand_G = 348,          /* VecDstOperand_G  */
  YYSYMBOL_VecDstOperand_G_I = 349,        /* VecDstOperand_G_I  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A_AO = 350, /* VecSrcOperand_G_I_IMM_A_AO  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A = 351,  /* VecSrcOperand_G_I_IMM_A  */
  YYSYMBOL_VecSrcOperand_G_I_IMM = 352,    /* VecSrcOperand_G_I_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM = 353,      /* VecSrcOperand_G_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM_AO = 354,   /* VecSrcOperand_G_IMM_AO  */
  YYSYMBOL_VecSrcOperand_G_A = 355,        /* VecSrcOperand_G_A  */
  YYSYMBOL_VecSrcOperand_G_A_AO = 356,     /* VecSrcOperand_G_A_AO  */
  YYSYMBOL_VecSrcOperand_G = 357,          /* VecSrcOperand_G  */
  YYSYMBOL_VecSrcOpndSimple = 358,         /* VecSrcOpndSimple  */
  YYSYMBOL_VMEOpndIME = 359,               /* VMEOpndIME  */
  YYSYMBOL_VMEOpndFBR = 360,               /* VMEOpndFBR  */
  YYSYMBOL_SrcStateOperand = 361,          /* SrcStateOperand  */
  YYSYMBOL_DstStateOperand = 362,          /* DstStateOperand  */
  YYSYMBOL_RawOperand = 363,               /* RawOperand  */
  YYSYMBOL_RawOperandNonNull = 364,        /* RawOperandNonNull  */
  YYSYMBOL_RawOperandOffsetSuffix = 365,   /* RawOperandOffsetSuffix  */
  YYSYMBOL_RawOperandArray = 366,          /* RawOperandArray  */
  YYSYMBOL_DstAddrOperand = 367,           /* DstAddrOperand  */
  YYSYMBOL_DstGeneralOperand = 368,        /* DstGeneralOperand  */
  YYSYMBOL_DstIndirectOperand = 369,       /* DstIndirectOperand  */
  YYSYMBOL_SrcAddrOfOperand = 370,         /* SrcAddrOfOperand  */
  YYSYMBOL_AddrOfVar = 371,                /* AddrOfVar  */
  YYSYMBOL_SrcAddrOperand = 372,           /* SrcAddrOperand  */
  YYSYMBOL_SrcGeneralOperand = 373,        /* SrcGeneralOperand  */
  YYSYMBOL_SrcImmOperand = 374,            /* SrcImmOperand  */
  YYSYMBOL_FloatLit = 375,                 /* FloatLit  */
  YYSYMBOL_DoubleFloatLit = 376,           /* DoubleFloatLit  */
  YYSYMBOL_SrcIndirectOperand = 377,       /* SrcIndirectOperand  */
  YYSYMBOL_DstRegion = 378,                /* DstRegion  */
  YYSYMBOL_SrcRegionDirect = 379,          /* SrcRegionDirect  */
  YYSYMBOL_SrcRegionIndirect = 380,        /* SrcRegionIndirect  */
  YYSYMBOL_IndirectVarAccess = 381,        /* IndirectVarAccess  */
  YYSYMBOL_TwoDimOffset = 382,             /* TwoDimOffset  */
  YYSYMBOL_PredVar = 383,                  /* PredVar  */
  YYSYMBOL_AddrVarAccess = 384,            /* AddrVarAccess  */
  YYSYMBOL_AddrVarAccessWithWidth = 385,   /* AddrVarAccessWithWidth  */
  YYSYMBOL_SIMDMode = 386,                 /* SIMDMode  */
  YYSYMBOL_ElemNum = 387,                  /* ElemNum  */
  YYSYMBOL_ExecSize = 388,                 /* ExecSize  */
  YYSYMBOL_ExecSizeInt = 389,              /* ExecSizeInt  */
  YYSYMBOL_Var = 390,                      /* Var  */
  YYSYMBOL_VarNonNull = 391,               /* VarNonNull  */
  YYSYMBOL_IntExp = 392,                   /* IntExp  */
  YYSYMBOL_IntExpCond = 393,               /* IntExpCond  */
  YYSYMBOL_IntExpAND = 394,                /* IntExpAND  */
  YYSYMBOL_IntExpXOR = 395,                /* IntExpXOR  */
  YYSYMBOL_IntExpOR = 396,                 /* IntExpOR  */
  YYSYMBOL_IntExpCmp = 397,                /* IntExpCmp  */
  YYSYMBOL_IntExpRel = 398,                /* IntExpRel  */
  YYSYMBOL_IntExpNRA = 399,                /* IntExpNRA  */
  YYSYMBOL_IntExpShift = 400,              /* IntExpShift  */
  YYSYMBOL_IntExpAdd = 401,                /* IntExpAdd  */
  YYSYMBOL_IntExpMul = 402,                /* IntExpMul  */
  YYSYMBOL_IntExpUnr = 403,                /* IntExpUnr  */
  YYSYMBOL_IntExpPrim = 404,               /* IntExpPrim  */
  YYSYMBOL_DataType = 405,                 /* DataType  */
  YYSYMBOL_DataTypeIntOrVector = 406,      /* DataTypeIntOrVector  */
  YYSYMBOL_BuildOptions = 407              /* BuildOptions  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3273

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  204
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  204
/* YYNRULES -- Number of rules.  */
#define YYNRULES  467
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1201

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   458


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   673,   673,   678,   680,   680,   682,   682,   683,   683,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   701,   702,   703,   707,   711,   714,   714,   721,   729,
     737,   744,   745,   746,   747,   748,   749,   751,   758,   766,
     774,   781,   785,   785,   788,   796,   801,   813,   820,   828,
     828,   829,   835,   839,   843,   847,   852,   858,   858,   860,
     864,   870,   878,   884,   889,   894,   900,   904,   908,   914,
     919,   925,   929,   939,   940,   941,   942,   943,   944,   945,
     946,   947,   948,   949,   950,   951,   952,   953,   954,   955,
     956,   957,   958,   959,   960,   961,   962,   963,   964,   965,
     966,   967,   968,   969,   970,   971,   972,   973,   974,   975,
     976,   977,   978,   979,   980,   981,   982,   983,   984,   985,
     986,   987,   988,   989,   990,   992,   996,  1002,  1007,  1013,
    1020,  1026,  1033,  1040,  1047,  1054,  1064,  1073,  1080,  1087,
    1096,  1106,  1112,  1119,  1125,  1134,  1144,  1151,  1158,  1166,
    1175,  1182,  1189,  1195,  1201,  1207,  1213,  1231,  1238,  1248,
    1256,  1263,  1270,  1279,  1288,  1297,  1305,  1308,  1311,  1314,
    1317,  1320,  1325,  1332,  1340,  1341,  1347,  1360,  1368,  1375,
    1380,  1385,  1402,  1402,  1404,  1404,  1407,  1424,  1442,  1442,
    1445,  1453,  1461,  1464,  1468,  1474,  1487,  1487,  1491,  1499,
    1511,  1527,  1533,  1546,  1554,  1561,  1569,  1575,  1581,  1587,
    1593,  1600,  1601,  1610,  1611,  1612,  1614,  1615,  1616,  1618,
    1621,  1622,  1623,  1624,  1625,  1626,  1628,  1655,  1687,  1717,
    1745,  1771,  1799,  1828,  1854,  1887,  1927,  1971,  2016,  2052,
    2091,  2096,  2096,  2099,  2100,  2104,  2113,  2119,  2128,  2148,
    2168,  2188,  2208,  2215,  2219,  2222,  2227,  2230,  2235,  2241,
    2249,  2262,  2263,  2264,  2269,  2270,  2273,  2274,  2275,  2276,
    2280,  2283,  2286,  2289,  2292,  2295,  2300,  2300,  2304,  2314,
    2322,  2330,  2344,  2348,  2354,  2359,  2362,  2366,  2369,  2375,
    2377,  2378,  2390,  2419,  2441,  2453,  2464,  2473,  2495,  2498,
    2501,  2508,  2512,  2516,  2520,  2526,  2531,  2538,  2545,  2550,
    2555,  2561,  2568,  2575,  2581,  2587,  2595,  2603,  2611,  2621,
    2626,  2631,  2636,  2641,  2646,  2651,  2656,  2661,  2661,  2667,
    2672,  2677,  2677,  2679,  2679,  2682,  2682,  2685,  2686,  2687,
    2688,  2690,  2690,  2695,  2696,  2698,  2699,  2703,  2704,  2707,
    2708,  2711,  2712,  2713,  2716,  2717,  2720,  2721,  2722,  2725,
    2726,  2729,  2730,  2732,  2734,  2744,  2751,  2759,  2767,  2786,
    2798,  2805,  2817,  2822,  2829,  2834,  2842,  2850,  2856,  2861,
    2883,  2887,  2893,  2903,  2911,  2918,  2928,  2934,  2941,  2945,
    2950,  2954,  2960,  2961,  2968,  2976,  2977,  2983,  2993,  3001,
    3010,  3028,  3042,  3045,  3056,  3067,  3072,  3077,  3085,  3094,
    3106,  3120,  3122,  3133,  3145,  3151,  3159,  3168,  3168,  3169,
    3169,  3172,  3174,  3175,  3177,  3178,  3180,  3181,  3183,  3184,
    3186,  3187,  3188,  3190,  3191,  3192,  3193,  3194,  3213,  3216,
    3217,  3218,  3219,  3221,  3222,  3223,  3225,  3226,  3231,  3236,
    3238,  3239,  3240,  3241,  3245,  3246,  3248,  3252,  3256,  3262,
    3271,  3272,  3273,  3274,  3275,  3277,  3278,  3281
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ALIGN_KEYWORD",
  "ATOMIC_SUB_OP", "DIRECTIVE_DECL", "DIRECTIVE_FUNC",
  "DIRECTIVE_FUNCDECL", "DIRECTIVE_GLOBAL_FUNC", "DIRECTIVE_IMPLICIT",
  "DIRECTIVE_INPUT", "DIRECTIVE_KERNEL", "DIRECTIVE_KERNEL_ATTR",
  "DIRECTIVE_VERSION", "ALIAS_EQ", "ALIGN_EQ", "ATTR_EQ", "OFFSET_EQ",
  "NUM_ELTS_EQ", "V_NAME_EQ", "SIZE_EQ", "V_TYPE_EQ_G", "V_TYPE_EQ_P",
  "V_TYPE_EQ_A", "V_TYPE_EQ_S", "V_TYPE_EQ_T", "CPS",
  "NON_UNIFORM_SAMPLER", "PIXEL_NULL_MASK", "RAW_SEND_STRING",
  "RAW_SENDC_STRING", "RAW_SENDS_STRING", "RAW_SENDS_EOT_STRING",
  "RAW_SENDSC_STRING", "RAW_SENDSC_EOT_STRING", "SAT", "SRCMOD_ABS",
  "SRCMOD_NEG", "SRCMOD_NEGABS", "SRCMOD_NOT", "BFN_OP", "DPAS_OP",
  "SVM_ALIGNED", "SVM_UNALIGNED", "NBARRIER_SIGNAL", "NBARRIER_WAIT",
  "ITYPE", "DECL_DATA_TYPE", "DFTYPE", "FTYPE", "HFTYPE", "BFTYPE",
  "VTYPE", "COND_MOD", "LANGLE", "RANGLE", "LBRACK", "RBRACK",
  "IND_LBRACK", "LPAREN", "RPAREN", "LBRACE", "RBRACE", "DOT", "COMMA",
  "SEMI", "COLON", "SLASH", "PERCENT", "EQUALS", "PLUS", "MINUS", "TIMES",
  "AMP", "CIRC", "PIPE", "TILDE", "BANG", "QUESTION", "LEQ", "GEQ", "EQ",
  "NEQ", "SHL", "SHRS", "SHRZ", "LABEL", "IDENT", "BUILTIN_NULL",
  "BUILTIN", "STRING_LIT", "NEWLINE", "BUILD_OPTION_LINE", "UNIFORM",
  "RTWRITE_OPTION", "MEDIA_MODE", "OWORD_MODIFIER", "SAMPLER_CHANNEL",
  "CHANNEL_OUTPUT", "EXECMODE", "CNTRL", "FENCE_OPTIONS", "ADDR_ADD_OP",
  "UNARY_LOGIC_OP", "BINARY_LOGIC_OP", "TERNARY_LOGIC_OP",
  "QUATERNARY_LOGIC_OP", "SEL_OP", "MIN_OP", "MAX_OP", "ANTI_TRIG_OP",
  "MATH2_OP", "MATH3_OP", "ARITH2_OP", "ARITH3_OP", "ARITH4_OP",
  "ARITH4_OP2", "ARITH5_OP2", "CMP_OP", "SVM_OP", "SVM_SCATTER_OP",
  "SVM_GATHER4SCALED_OP", "SVM_SCATTER4SCALED_OP", "SVM_ATOMIC_OP",
  "OWORD_OP", "MEDIA_OP", "SCATTER_OP", "SCATTER_TYPED_OP",
  "SCATTER_SCALED_OP", "SCATTER4_SCALED_OP", "BARRIER_OP",
  "SBARRIER_SIGNAL", "SBARRIER_WAIT", "DWORD_ATOMIC_OP", "TYPED_ATOMIC_OP",
  "SAMPLE_OP", "SAMPLE_UNORM_OP", "VME_IME_OP", "VME_SIC_OP", "VME_FBR_OP",
  "BRANCH_OP", "RET_OP", "IFCALL", "FCALL", "FADDR", "SWITCHJMP_OP",
  "MOVS_OP", "SETP_OP", "MOV_OP", "FILE_OP", "LOC_OP", "CACHE_FLUSH_OP",
  "WAIT_OP", "FENCE_GLOBAL_OP", "FENCE_LOCAL_OP", "FENCE_SW_OP",
  "YIELD_OP", "SAMPLE_3D_OP", "LOAD_3D_OP", "SAMPLE4_3D_OP",
  "RESINFO_OP_3D", "SAMPLEINFO_OP_3D", "RTWRITE_OP_3D", "URBWRITE_OP_3D",
  "LIFETIME_START_OP", "LIFETIME_END_OP", "AVS_OP", "BREAKPOINT_OP",
  "CALL_OP", "PRED_CNTL", "F32_LIT", "F64_LIT", "DEC_LIT", "HEX_LIT",
  "BUILTIN_SIZEOF", "BUILTIN_DISPATCH_SIMD_SIZE", "QW_SCATTER_OP",
  "LSC_CACHING_OPT", "LSC_ADDR_SIZE_TK", "LSC_DATA_SHAPE_TK",
  "LSC_DATA_SHAPE_TK_CHMASK", "LSC_DATA_SHAPE_TK_BLOCK2D", "LSC_AM_FLAT",
  "LSC_AM_BTI", "LSC_AM_BSS", "LSC_AM_SS", "LSC_AM_ARG",
  "LSC_FENCE_OP_TYPE", "LSC_FENCE_SCOPE", "LSC_SFID_UNTYPED_TOKEN",
  "LSC_SFID_TYPED_TOKEN", "LSC_LOAD_MNEMONIC", "LSC_LOAD_STRIDED_MNEMONIC",
  "LSC_LOAD_BLOCK2D_MNEMONIC", "LSC_STORE_MNEMONIC",
  "LSC_STORE_STRIDED_MNEMONIC", "LSC_STORE_BLOCK2D_MNEMONIC",
  "LSC_ATOMIC_MNEMONIC", "LSC_READ_STATE_INFO_MNEMONIC",
  "LSC_LOAD_MSRT_MNEMONIC", "LSC_STORE_MSRT_MNEMONIC",
  "LSC_FENCE_MNEMONIC", "FCVT_OP", "LSC_DATA_SHAPE_TK_TYPED_BLOCK2D",
  "$accept", "Listing", "ListingHeader", "Statements", "Newlines",
  "NewlinesOpt", "Statement", "Scope", "ScopeStart", "ScopeEnd",
  "IdentOrStringLit", "DirectiveKernel", "DirectiveGlobalFunction",
  "DirectiveVersion", "DirectiveDecl", "DeclFunction", "DeclVariable",
  "DeclAddress", "DeclPredicate", "DeclSampler", "VNameEqOpt",
  "DeclSurface", "DirectiveInput", "DirectiveImplicitInput", "InputOffset",
  "InputSize", "DirectiveAttr", "DirectiveFunc", "AlignAttrOpt", "Align",
  "AliasAttrOpt", "OneAttr", "AttrOpt", "GenAttrOpt", "Instruction",
  "Label", "LogicInstruction", "UnaryLogicInstruction",
  "MathInstruction_2OPND", "MathInstruction_3OPND",
  "ArithInstruction_2OPND", "ArithInstruction_3OPND",
  "ArithInstruction_4OPND", "DpasInstruction", "BfnInstruction",
  "QwScatterInstruction", "FCvtInstruction", "AntiTrigInstruction",
  "AddrAddInstruction", "SetpInstruction", "SelInstruction",
  "MinInstruction", "MaxInstruction", "MovInstruction",
  "BreakpointInstruction", "MovsInstruction", "CmpInstruction",
  "MediaInstruction", "MediaInstructionPlaneID", "ScatterInstruction",
  "ScatterTypedInstruction", "Scatter4ScaledInstruction",
  "ScatterScaledInstruction", "SynchronizationInstruction",
  "DwordAtomicInstruction", "TypedAtomicInstruction", "Atomic16Opt",
  "SampleUnormInstruction", "SampleInstruction", "SamplerAddrOperand",
  "Sample3dInstruction", "CPSEnableOpt", "NonUniformSamplerEnableOpt",
  "Load3dInstruction", "Gather43dInstruction", "PixelNullMaskEnableOpt",
  "ResInfo3dInstruction", "SampleInfo3dInstruction", "RTWriteOperands",
  "RTWriteInstruction", "RTWriteModeOpt", "URBWriteInstruction",
  "AVSInstruction", "VMEInstruction", "OwordInstruction", "SvmInstruction",
  "AtomicBitwidthOpt", "LscInstruction", "LscUntypedLoad",
  "LscUntypedStridedLoad", "LscUntypedBlock2dLoad", "LscUntypedStore",
  "LscUntypedStridedStore", "LscUntypedBlock2dStore", "LscUntypedAtomic",
  "LscTypedMSRTLoad", "LscTypedMSRTStore", "LscTypedLoad", "LscTypedStore",
  "LscTypedAtomic", "LscTypedReadStateInfo", "LscFence", "LscSfid",
  "LscCacheOpts", "LscUntypedAddrOperand", "LscUntypedStridedAddrOperand",
  "LscUntypedBlock2dAddrOperand", "LscTypedAddrWithOffsetOperand",
  "LscTypedAddrWithOffsetOperandList", "LscTypedAddrOperandWithOffsets",
  "LscAddrImmOffsetOpt", "LscAddrImmScaleOpt", "LscAddrModelOpt",
  "LscAddrModelStateful", "LscVectorOpRegOrImm32", "LscVectorOpImm32",
  "LscVectorOpReg", "LscDataOperand", "LscDataOperand2D", "LscPayloadReg",
  "LscPayloadNonNullReg", "LscInstructionXe2", "LscTypedBlock2dLoad",
  "LscTypedBlock2dStore", "LscTypedBlock2dAddrOperand",
  "LscDataOperandTyped2D", "LscUntypedApndCtrAtomic", "SwitchLabels",
  "BranchInstruction", "FILE", "LOC", "RawSendInstruction",
  "LifetimeStartInst", "LifetimeEndInst", "RawSendsInstruction",
  "NullaryInstruction", "OwordModifier", "Predicate", "PredSign",
  "PredCtrlOpt", "SatModOpt", "SrcModifier", "ConditionalModifier",
  "VecDstOperand_A", "VecDstOperand_G", "VecDstOperand_G_I",
  "VecSrcOperand_G_I_IMM_A_AO", "VecSrcOperand_G_I_IMM_A",
  "VecSrcOperand_G_I_IMM", "VecSrcOperand_G_IMM", "VecSrcOperand_G_IMM_AO",
  "VecSrcOperand_G_A", "VecSrcOperand_G_A_AO", "VecSrcOperand_G",
  "VecSrcOpndSimple", "VMEOpndIME", "VMEOpndFBR", "SrcStateOperand",
  "DstStateOperand", "RawOperand", "RawOperandNonNull",
  "RawOperandOffsetSuffix", "RawOperandArray", "DstAddrOperand",
  "DstGeneralOperand", "DstIndirectOperand", "SrcAddrOfOperand",
  "AddrOfVar", "SrcAddrOperand", "SrcGeneralOperand", "SrcImmOperand",
  "FloatLit", "DoubleFloatLit", "SrcIndirectOperand", "DstRegion",
  "SrcRegionDirect", "SrcRegionIndirect", "IndirectVarAccess",
  "TwoDimOffset", "PredVar", "AddrVarAccess", "AddrVarAccessWithWidth",
  "SIMDMode", "ElemNum", "ExecSize", "ExecSizeInt", "Var", "VarNonNull",
  "IntExp", "IntExpCond", "IntExpAND", "IntExpXOR", "IntExpOR",
  "IntExpCmp", "IntExpRel", "IntExpNRA", "IntExpShift", "IntExpAdd",
  "IntExpMul", "IntExpUnr", "IntExpPrim", "DataType",
  "DataTypeIntOrVector", "BuildOptions", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1085)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-455)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -16, -1085,   110,    29,   151, -1085, -1085,    52,   -16, -1085,
     170,  2940,    80,   239,   243,   186,   243,   244,   247,   243,
     263,   252,   938,   938,   282, -1085, -1085, -1085,   252,   315,
      12,   284,   277,   311, -1085, -1085, -1085,   281,   301,   331,
     231,   342,   243,   252,   252,   252,   313,   254, -1085,   848,
     341,   346, -1085, -1085,   365,   382,   417,   420,   419, -1085,
     -50,   480,   -16, -1085, -1085,  2742, -1085, -1085, -1085, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,
    3023, -1085, -1085,   407, -1085, -1085, -1085, -1085, -1085,   501,
     501, -1085,   450,    -9,   269, -1085, -1085, -1085, -1085,   231,
     320,   293,   320,   320, -1085, -1085, -1085, -1085, -1085,    99,
     387,   -20, -1085,    40,   938, -1085, -1085, -1085, -1085, -1085,
   -1085,   466,   462, -1085,    37, -1085, -1085, -1085,   231,   231,
   -1085,   252,   252,   252,   938, -1085,   252,   462,   350,   252,
     464,   427,   354,   231,   269,   938,   231,    40,   938,   231,
     231, -1085, -1085,   231, -1085, -1085, -1085, -1085, -1085,   252,
     252, -1085, -1085,   231, -1085, -1085,   340, -1085,   252,  1230,
   -1085, -1085,  2080,   252,   252,   311,   311,   311,   311,   480,
     480,   480,   480,   480,   480,   480,   480,   480,   480,   480,
     480,   480,   480,   252,   252,   465,   432,   433,   527,   436,
     471,   439,   534,   535,   252,   252,   -12,   252,   480,   512,
     512,   512,   447,   252,   252,   482,    23,   358,   116,   157,
     359,   195,   250,   356,   361,   364,   508,   538,   539,   540,
     541,   320,   150,   544,    36, -1085,   500,   502,   505,   269,
   -1085,   507,    58,   506,   320, -1085, -1085,   514, -1085,   -27,
     503,   509, -1085,   388,    14, -1085,   172,    33, -1085,   424,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,
     488, -1085,   466,   462,   938,   320, -1085,   229,   320,   524,
   -1085, -1085, -1085,   414, -1085,    48, -1085, -1085,   522,    40,
     938,   938,   269,   231,   231, -1085,   284,   430,   231,   231,
     543,   269,   269,   545,   269, -1085, -1085, -1085,   549,   114,
     546,   231,   938, -1085,   126,   938,   -23,   -23,   231,   422,
     231, -1085, -1085,   -16, -1085,   441,   442,   311,   311,   311,
     311,   252,   252,   252,   252,   252,   252,   252,   252,   252,
     252,   252,   252,   252,   252,    40,    40,   440,   252,   252,
     556,   252,   448,   252,   559,   559,   243, -1085,   252,   938,
     536,   252, -1085,   598,   528,   529, -1085,   252,   455,   243,
     457,   454,   454,   454,   454,   454,   454,   454,   454,   454,
     454,   454,   454,   357,   454,   454,   614,   320,   320,   320,
     320, -1085,   572,   320,   618, -1085, -1085, -1085, -1085, -1085,
     463,   489,   269,   -30, -1085, -1085,   320,   320, -1085,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   594,   229,   524,
     938,   410,   160, -1085, -1085, -1085, -1085, -1085, -1085,   596,
     320, -1085, -1085,   605,   231, -1085,   278, -1085, -1085,   610,
   -1085, -1085,   608,   320,   938,   938,   114,   269,   269, -1085,
     938,  1138,   231,   612,   357,   231,   498,   269,   269,   938,
     269,   320,   229, -1085,   549,    -5, -1085,   616, -1085, -1085,
     620,   320, -1085,   231,   269, -1085,   269,   938, -1085,   848,
     619,   510,   511,   311,   311,   311,   311,    40,    40,    40,
      40,    40,    40,    40,    40,    40,    40,    40,    40,    40,
      40,    40,   231,   617,   938,   938,   513,   252,   231,   252,
     231,   518,   252,   252, -1085,   938,   519,   520,    40, -1085,
     657,   252,   252,   231,   521, -1085,   252,   517,   252,   252,
     252,   252,   357,   252,   252,   252,   252,   276,   252,   252,
     505,   276, -1085, -1085,   507,   252,   252,   320,   618,   618,
     678,   678,   626, -1085, -1085,   639, -1085,   231,   320, -1085,
     658,   654,   503,    38,   509, -1085, -1085, -1085, -1085, -1085,
   -1085, -1085,    33,    33,   406,   406,   406, -1085, -1085, -1085,
   -1085, -1085, -1085, -1085,   547,   320,   320,   320,   651, -1085,
   -1085, -1085, -1085, -1085, -1085,   320,   320,   661,   938,   938,
   -1085, -1085,   269,   198,   938,   938,   938, -1085,   269,   269,
     938,   662,   269, -1085,   659,   269,   663, -1085, -1085,    -5,
      -5,   664,   320,   320,   163,   665,   269, -1085,   938, -1085,
   -1085,   553,   554,   311,   311,   252,   252,   938,   938,   231,
     938,   231,   938,   938,   938,   938,   938,   938,   938,   938,
     938,   938,   938,   938,   938,   558,   269,   269, -1085,   269,
     269,   231,   938, -1085,   231,   231,   562,   563,   564,   600,
     600,   171, -1085,   631,   938,   938, -1085,   269,   231, -1085,
     357,   357,   357,   357,   537,   276,   272,   276,   272,   560,
     672,   679,   682,   687,   357,   357,   357,   688,   357,   276,
     730, -1085, -1085,   660,   618,   618,   677, -1085,    69, -1085,
   -1085,   462,   692, -1085, -1085,   320,   698,   690,   695,   699,
     189,   703, -1085, -1085, -1085,   938,   269,   269,   269,   269,
     938, -1085,   269,   938, -1085, -1085, -1085, -1085, -1085,   700,
     224, -1085,    31, -1085,   938,   848,   848,   252,   252,   848,
     848,   938, -1085, -1085,   938,   231,   938,   938,   938,   938,
     938, -1085, -1085,   938, -1085,   938,   938,   938,   938,   252,
     269,   269,   269,   269,   938,   269,   269,   269,   586, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,   608,   252,
     -23,   -23,  1264,   269,   269,   272,   303,   276,   272,   560,
     580, -1085, -1085, -1085, -1085,   357,   708, -1085,   357,   709,
   -1085,   357,   710,   713,   357,   -15,   -15,   -15,   -15, -1085,
     272,   276,    67,   276,   357,    47,   763, -1085, -1085, -1085,
   -1085,   312, -1085,   626, -1085, -1085, -1085, -1085,   320, -1085,
   -1085,   320,   269, -1085,   269,   269,   269,   938,   269,   722,
   -1085,   724,   938,   269,   269,   848,   848,   848,   848,   938,
   -1085, -1085,   938,   938, -1085, -1085, -1085, -1085, -1085,   938,
   -1085, -1085,   269, -1085, -1085,   269,   269,   269,   269,   269,
     269, -1085,   938,   269,   -23, -1085, -1085,   269,   269, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085,    31, -1085,    67,
   -1085,    31,   231, -1085,   232, -1085, -1085,   238, -1085,   240,
     261,   721,   418,   357,   357,   357,   729, -1085,   507, -1085,
   -1085, -1085, -1085, -1085, -1085,   733,   618, -1085, -1085, -1085,
     734,   735, -1085, -1085, -1085,   269,   938,   269, -1085, -1085,
     938,   269,   269,   848,   848,   269,   269, -1085, -1085,   938,
   -1085,   269,   269,   269,   269, -1085,   269,   269,   -23,   269,
     269,   269, -1085,    67,   723,   736,   741,   426,    67,    27,
   -1085,   320,   320,   627, -1085,   320, -1085,   320,   320,   320,
     320,   737,   357, -1085,   357, -1085,    62, -1085, -1085, -1085,
   -1085,   269, -1085,   938, -1085, -1085,   269,   269,   269,   269,
   -1085, -1085, -1085,   269, -1085,   269,   269,   -23, -1085,   269,
   -1085,   418, -1085,    67,   625,   320,   320,   418,   -15,   745,
     746,   743, -1085,   748,   750,   754,   406,    33,   231, -1085,
   -1085, -1085,   749, -1085,   938,   269,   269,   269,   269, -1085,
   -1085,   269,   269,   269, -1085,   762,   756, -1085,    33,    33,
      68,   758,   320, -1085,   320, -1085, -1085, -1085,   418,   320,
     705,   269,   269, -1085, -1085,   269,   269, -1085,   269,   649,
      67,   -15,   -15,   764,   769,   773,   776,   938, -1085, -1085,
     269, -1085, -1085,   771,   779,   775,   320, -1085, -1085, -1085,
     742, -1085,   269,    67,   666,   -15,   780,   938, -1085, -1085,
     778,   786,   269,   -15, -1085, -1085,   781,   418,   -15,   784,
     792,   418,   -15, -1085,   795,   808,   418, -1085, -1085,   811,
   -1085
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       8,     7,     0,     9,     0,     1,     6,     0,     8,     3,
       0,   329,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   331,    24,   125,   467,     0,   341,
       0,   327,     0,     0,   166,   167,   168,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   319,     0,
     322,   324,   326,   321,     0,     0,     0,     0,     0,   153,
       0,   335,     8,     5,    19,     0,    11,    12,    10,    36,
      31,    32,    33,    34,    35,    14,    13,    16,    15,    17,
      18,    73,    75,    76,    77,    78,    79,    80,   118,   119,
     120,   122,    81,    82,   103,   100,   101,   102,    99,   124,
      98,    83,    84,    86,    87,    89,    88,    90,    92,    93,
      95,    94,   108,   109,   110,   111,   112,   113,   114,    97,
      96,    85,    74,   121,   213,   214,   215,   216,   217,   218,
     219,   224,   225,   220,   221,   222,   223,   226,   123,   290,
     291,   289,    91,   104,   105,   106,   115,   116,   107,   117,
       0,    20,    30,     0,    26,    27,    56,    37,    29,    49,
      49,    28,    54,     0,     0,   338,   337,   339,   340,     0,
       0,     0,     0,     0,   419,   418,   420,   392,   395,   454,
     455,     0,   459,     0,     0,   351,   363,   353,   388,   390,
     352,     0,     0,   417,     0,   453,   171,   332,     0,     0,
     342,     0,     0,     0,     0,   328,     0,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   309,   310,     0,   320,   354,   355,   323,   325,     0,
       0,   313,   314,     0,   241,   242,     0,   336,     0,   329,
       2,    23,   329,     0,     0,     0,     0,     0,     0,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   335,   188,
     188,   188,   196,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    71,    46,    55,   416,     0,     0,     0,     0,
     369,     0,     0,     0,     0,   454,   455,     0,   421,   423,
     425,   427,   429,   432,   437,   438,   442,   445,   449,   455,
     389,   391,   450,   451,   452,   396,   393,   397,   394,   387,
       0,   457,     0,     0,   170,     0,   402,     0,     0,     0,
     465,   466,   386,   333,   408,     0,   343,   376,     0,     0,
       0,     0,     0,     0,     0,   413,   327,     0,     0,     0,
       0,     0,     0,     0,     0,   308,   345,   346,     0,     0,
       0,     0,     0,   344,     0,     0,     0,     0,     0,     0,
       0,     4,    25,     8,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,     0,     0,     0,   174,   174,     0,   303,     0,     0,
       0,     0,   189,   182,     0,     0,   197,     0,     0,     0,
       0,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,     0,   243,   243,     0,     0,     0,     0,
       0,    50,     0,     0,    71,    48,    45,    52,    53,   414,
       0,     0,     0,     0,   371,   406,     0,     0,   456,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   437,   461,   462,   463,   464,   398,   460,     0,
       0,   384,   334,     0,     0,   361,     0,   359,   362,   380,
     360,   383,     0,     0,     0,     0,   408,     0,     0,   206,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   378,     0,   298,   155,     0,   156,   154,
       0,     0,   146,     0,     0,   179,     0,     0,   240,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   301,     0,     0,     0,     0,   183,
     184,     0,     0,     0,     0,   302,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     418,     0,   285,   286,   417,     0,     0,     0,    71,    71,
      42,    42,     0,    51,    47,     0,   370,     0,     0,   372,
       0,     0,   424,     0,   426,   428,   430,   431,   433,   434,
     435,   436,   443,   444,   439,   440,   441,   447,   448,   446,
     458,   399,   385,   169,     0,     0,   404,     0,     0,   330,
     382,   145,   356,   358,   357,     0,     0,     0,     0,     0,
     204,   205,     0,   161,     0,     0,     0,   412,     0,     0,
       0,     0,     0,   201,     0,     0,     0,   379,   377,   298,
     298,     0,     0,     0,     0,     0,     0,   191,     0,   143,
      22,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   212,     0,
       0,     0,     0,   175,     0,     0,     0,     0,     0,     0,
       0,     0,   185,     0,     0,     0,   192,     0,     0,   244,
       0,     0,     0,     0,     0,     0,   266,     0,   266,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      57,    40,    39,     0,    71,    71,    68,    70,     0,   415,
     140,     0,     0,   405,   409,     0,     0,     0,     0,     0,
       0,     0,   158,   157,   203,     0,     0,     0,     0,     0,
       0,   365,     0,     0,   202,   400,   299,   300,   304,     0,
       0,   368,     0,   190,     0,     0,     0,     0,     0,     0,
       0,     0,   130,   131,     0,     0,     0,     0,     0,     0,
       0,   144,   132,     0,   134,     0,     0,     0,   136,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   306,
     305,   151,   347,   349,   348,   350,   150,   152,   408,     0,
       0,     0,   195,     0,     0,   266,     0,     0,   266,     0,
       0,   296,   292,   267,   268,     0,     0,   269,     0,     0,
     247,     0,     0,     0,     0,     0,     0,     0,     0,   293,
     266,     0,     0,     0,     0,     0,    63,    58,    43,    41,
      44,     0,    72,     0,   364,   373,   422,   403,     0,   407,
     381,     0,     0,   160,     0,     0,     0,     0,     0,     0,
     367,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     126,   127,     0,     0,   147,   148,   149,   133,   135,     0,
     138,   139,     0,   209,   210,     0,     0,     0,     0,     0,
       0,   307,     0,     0,     0,   193,   194,     0,     0,   227,
     282,   283,   236,   228,   229,   284,   230,   264,   237,     0,
     231,   264,     0,   232,     0,   277,   276,   279,   278,     0,
       0,     0,   261,     0,   269,     0,     0,   287,   288,   234,
     235,    62,    59,    60,    61,     0,    71,    67,    66,    69,
       0,     0,   159,   162,   178,     0,     0,     0,   366,   180,
       0,     0,     0,     0,     0,     0,     0,   141,   128,     0,
     137,     0,     0,     0,     0,   164,     0,     0,     0,     0,
       0,     0,   142,     0,     0,   256,     0,   253,     0,     0,
     274,     0,     0,     0,   270,     0,   272,     0,     0,     0,
       0,     0,     0,   297,     0,   239,     0,    38,   401,   410,
     177,     0,   200,     0,   311,   312,     0,     0,     0,     0,
     129,   207,   208,     0,   165,     0,     0,     0,   374,     0,
     198,   261,   265,     0,     0,     0,     0,   261,     0,     0,
       0,     0,   280,     0,     0,     0,   262,   263,     0,   233,
     238,    65,     0,   176,     0,     0,     0,     0,     0,   163,
     172,     0,     0,   186,   374,     0,   257,   260,   254,   255,
       0,     0,     0,   275,     0,   271,   273,   294,   261,     0,
       0,     0,     0,   317,   318,     0,     0,   375,   187,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   315,   316,
       0,   374,   245,   258,     0,     0,     0,   281,   295,    64,
       0,   173,   181,     0,     0,     0,     0,     0,   259,   246,
       0,     0,     0,     0,   252,   199,     0,   261,     0,     0,
       0,   261,     0,   249,     0,     0,   261,   250,   251,     0,
     248
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1085, -1085, -1085,   628,   -48,    34,   630, -1085, -1085,   314,
      -1, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,
     241, -1085, -1085, -1085,   711,   570, -1085, -1085, -1085, -1085,
   -1085,   -38, -1085,  -457, -1085, -1085, -1085, -1085, -1085, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085,   451, -1085, -1085,  -360,
   -1085, -1085, -1085, -1085, -1085,   218, -1085, -1085, -1085, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085, -1085,
   -1085, -1085, -1085,   412,  -745,     0,    -2, -1062, -1085,  -736,
    -843,  -100,  -740,  -568,  -862,  -889,  -890,  -659,   -11,  -451,
    -864, -1085, -1085, -1085,   125,   117, -1085,  -199, -1085, -1085,
   -1085, -1085, -1085, -1085, -1085, -1085,   530, -1085, -1085, -1085,
     391,    21, -1085,   296,   542,  -307,   145, -1085,   -22,  -543,
   -1085, -1085, -1085,   158, -1085, -1085, -1085,   515, -1085,  1456,
    -865, -1085, -1084, -1085,  -200, -1085,  -325, -1085,   573, -1085,
       8,   727,   728, -1085,  -358,  -304,   566,  -157,  -190,  -207,
   -1085,  -189, -1085,  -223,  2404,   431,    18,   886,   819,   105,
     438,   423,   449,   429,    22,  -342, -1085,  -487,  -478,   578,
    -789,  -466,   739, -1085
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     8,    62,     3,     4,    63,    64,    65,   394,
     156,    66,    67,     9,    68,    69,    70,    71,    72,    73,
     784,    74,    75,    76,   302,   464,    77,    78,   906,   907,
    1006,   787,   788,   465,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   684,   103,
     104,   105,   106,   107,   108,   109,   592,   110,   111,   554,
     112,   600,   753,   113,   114,   433,   115,   116,   872,   117,
     437,   118,   119,   120,   121,   122,   587,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   236,   608,   890,   891,   894,  1045,  1046,   888,
    1061,  1043,   886,   889,   984,   985,   986,   875,   879,   876,
    1047,   138,   139,   140,   774,   765,   141,   701,   142,   143,
     144,   145,   146,   147,   148,   149,   206,   150,   198,   513,
     238,   183,   201,   355,   381,   375,   861,   862,   863,   224,
     671,   515,   516,   185,   790,   213,   216,   546,   382,   622,
     310,   474,  1123,   356,   376,   377,   864,   519,   865,   186,
     187,   188,   189,   190,   543,   346,   347,   191,   349,   353,
     312,   521,   368,   209,   164,   306,   192,   193,   988,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   194,
     195,   507,   508,   151
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     184,   196,   621,   502,   654,   655,   656,   634,   992,   991,
     357,   652,   653,   385,   239,   158,   709,   364,   161,   383,
     542,   885,   397,   398,   399,   400,   342,   556,   892,   638,
     518,  1126,   661,   931,   989,   990,   553,   997,   996,   340,
    1148,   217,    11,   904,   170,   511,   479,   163,  1001,   773,
    1002,   480,   524,   777,   202,   203,   314,   226,   214,   699,
     378,   172,   173,  1111,   174,   175,   176,   341,   485,   486,
     223,   163,   174,   175,   176,     1,   697,  1172,   174,   175,
     176,   428,   700,   350,   165,   166,   167,   168,  1163,   351,
     170,  1098,  1049,   487,   488,   170,   240,  1099,   169,   242,
     494,   495,   877,   878,   795,   496,   170,   314,   581,   582,
       5,   479,   172,   173,   997,   475,   900,   901,   314,   903,
       6,   514,   476,   172,   173,  1149,   467,   174,   175,   176,
     969,   912,  1151,   913,  1003,   174,   175,   176,   892,   234,
     235,   972,   639,   648,   649,   650,   651,   335,   336,   174,
     175,   176,   525,   499,   174,   993,   176,   315,   316,   181,
     182,   764,   344,   305,     7,   995,   462,   999,   541,  1105,
     463,   781,   782,   348,   563,   564,   565,   566,   997,  1091,
     541,   307,   362,   997,  1097,   551,   698,   313,  1044,   544,
     383,   673,  1044,   373,   544,   662,   380,   773,   887,   696,
     887,   343,   378,   315,   316,   181,   182,   225,   315,   316,
     181,   182,   441,   442,   485,   666,   354,   358,  1138,   315,
     316,   181,   182,   821,    10,   541,   976,   667,   997,   978,
     676,   371,   980,    12,   374,   379,  1131,   384,   354,   487,
     488,   343,   489,   490,  -454,  1000,   335,   336,  1125,   801,
    -454,   388,   152,   667,  1130,   491,   492,   493,   378,   378,
     717,   718,   720,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   350,   157,   503,   504,   505,
     506,   351,   933,   934,   930,   997,   937,   938,   667,  1164,
    1165,   750,  1050,  1187,  1186,  1155,  1051,  1052,  1191,  1190,
    1054,  1053,  1196,  1195,  1055,   444,   445,   887,   997,  1178,
     887,   163,   880,  1180,   165,   166,   167,   168,   174,   175,
     176,  1056,   500,   764,   649,  1057,   153,   909,   910,   965,
     154,   159,   994,   155,   160,  1063,   544,   170,   527,   528,
     713,   714,   715,   716,  1189,   239,   446,   447,  1194,   171,
     162,   514,   170,  1199,   172,   173,   174,   308,   176,   197,
     548,   719,   721,   552,   314,   174,   175,   176,   200,   172,
     173,   170,   207,   522,   208,   734,   223,   526,   210,   170,
     205,   530,   531,   314,   449,   450,   534,   535,   172,   173,
     212,   314,  1023,  1024,  1025,  1026,   172,   173,   211,   547,
     550,   215,  1007,   221,   555,   555,   557,   596,   379,   357,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   594,   222,   560,   296,   297,
     298,   299,   300,   379,   379,   337,   338,   339,   605,   451,
     452,   378,   227,   880,   174,   620,   176,   228,   177,   178,
     179,   180,   181,   182,   883,   770,   771,   772,   884,   770,
     771,   772,   229,   177,   178,   179,   329,   181,   182,   483,
     484,   623,   337,   338,   664,   665,   489,   490,   663,   230,
    1076,  1077,   970,   971,   315,   316,   181,   182,  1059,  1060,
     827,   828,   315,   316,   181,   182,  1095,  1096,   434,   435,
     816,   817,   678,   679,   231,   646,   647,   232,   682,   685,
     963,   964,   833,   517,   835,   237,   233,   694,   301,   304,
     345,   348,   365,   367,   674,   369,   370,   389,   417,   418,
     419,   420,   670,   421,   422,   708,   423,   223,   424,   425,
     432,   436,  1062,   867,  1064,   440,   453,   443,   448,  1067,
     686,   454,   689,   690,   455,   456,   457,   458,   459,   460,
     469,   544,   736,   737,   463,   477,   470,   226,   471,  1008,
     473,   705,  1106,   746,   478,   497,  1010,   481,   510,  1011,
     223,   523,  1107,   512,   482,   379,   526,   526,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     354,   914,   533,   541,  1040,   545,   740,   536,   742,   539,
     558,  1109,   583,  1110,   561,   562,   751,  1128,  1129,   586,
     589,   756,   591,   597,   599,   601,   602,   604,   941,   606,
     623,   607,   627,   632,   462,   305,   165,   166,   167,   168,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   660,   791,   802,   803,   169,   170,
     667,   636,   805,   806,   807,   669,   675,   676,   810,   431,
     691,   171,   687,   514,   672,   702,   172,   173,  1087,   703,
     735,   392,   711,   712,   752,   738,   824,   174,   175,   176,
     743,   747,   748,   757,   759,   831,   832,   783,   834,   789,
     836,   837,   838,   839,   840,   841,   842,   843,   844,   845,
     846,   847,   848,   786,   794,   793,   665,   225,   815,   796,
     855,   801,   811,   813,   818,   825,   826,  1122,   869,   822,
     849,   895,   870,   871,   858,   859,   860,   354,   896,   354,
     881,   897,   893,   898,   902,   905,   911,   908,   328,   332,
     333,   334,   915,   917,   918,   919,   920,   921,   961,   854,
     930,   975,   856,   857,   977,   979,   981,   522,   868,   982,
     177,   178,   179,   180,   181,   182,   874,  1005,   623,   623,
     623,   623,  1018,   922,  1019,  1058,  1065,  1066,   927,  1068,
    1069,   929,   623,   623,   623,  1092,   623,  1156,  1094,  1102,
    1093,  1108,   932,  1127,  1132,  1157,  1133,  1134,  1135,   939,
    1136,  1137,   940,  1139,   942,   943,   944,   945,   946,  1149,
    1150,   947,  1152,   948,   949,   950,   951,  1162,  1166,  1167,
    1168,  1169,   957,   226,   226,  1173,  1174,   226,   226,  1175,
    1181,  1177,  1183,  1184,  1179,  1188,   223,   223,  1192,  1193,
     223,   223,  1197,   354,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,  1198,   625,   626,  1200,   391,
     393,   303,   785,   466,   710,  1009,   593,   974,   973,   328,
     226,  1048,   328,   983,   165,   166,   167,   168,   555,   555,
     882,   899,   332,   223,   749,   866,   532,   549,   330,   331,
     916,   635,   642,   623,     0,  1016,   623,   170,   498,   623,
    1020,   645,   623,   987,   987,   987,   987,  1027,   643,   171,
    1028,  1029,   623,   328,   172,   173,   328,  1030,   520,     0,
     644,     0,   559,   352,     0,   174,   175,   176,     0,     0,
    1038,     0,     0,   226,   226,   226,   226,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   223,   223,   223,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   165,   166,   167,   168,     0,     0,
       0,     0,   555,   225,   225,     0,     0,   225,   225,   317,
       0,     0,     0,     0,  1071,     0,   169,   170,  1073,     0,
     987,     0,     0,     0,     0,     0,     0,  1080,     0,   171,
       0,   623,   623,   623,   172,   173,     0,     0,   177,   178,
     179,   180,   181,   182,     0,   174,   175,   176,     0,     0,
     225,   226,   226,     0,     0,   328,   328,   328,   328,     0,
       0,   328,     0,     0,   223,   223,     0,     0,     0,     0,
     311,  1114,     0,     0,   328,   328,   555,   328,   328,   328,
     328,   328,   328,   328,   328,   328,   328,   328,   328,   328,
     328,   328,   657,   658,   659,     0,     0,     0,     0,     0,
     623,     0,   623,     0,  1112,     0,     0,     0,   328,     0,
       0,     0,  1140,   225,   225,   225,   225,     0,     0,     0,
     311,   328,     0,     0,     0,   555,     0,     0,   177,   178,
     179,   180,   181,   182,     0,     0,   987,     0,     0,   328,
     461,     0,     0,   468,     0,     0,   987,     0,     0,   328,
       0,     0,     0,     0,     0,  1170,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1182,     0,     0,     0,     0,
       0,     0,     0,     0,   501,     0,     0,   509,     0,   987,
     987,     0,     0,     0,   165,   166,   167,   168,     0,     0,
       0,   225,   225,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   987,     0,   311,   169,   170,     0,     0,
       0,   987,     0,     0,     0,   328,   987,     0,     0,   171,
     987,     0,     0,     0,   172,   173,   328,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,     0,     0,
      -9,     0,     0,     0,     0,    13,    14,    15,    16,    17,
      18,    19,    20,   328,   328,   328,     0,     0,   311,     0,
       0,     0,     0,   328,   328,     0,     0,   311,   311,     0,
     311,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    21,     0,     0,    22,    23,   628,   629,   630,   631,
     328,   328,   633,     0,     0,     0,     0,     0,     0,    24,
       0,    25,    -9,     0,     0,   640,   641,     0,     0,     0,
     165,   166,   167,   168,     0,     0,     0,     0,   177,   178,
     683,   180,   181,   182,     0,     0,    26,     0,     0,     0,
       0,     6,    27,   170,     0,     0,     0,     0,     0,   668,
       0,     0,    28,     0,     0,   171,     0,     0,     0,   624,
     172,   173,   677,     0,     0,     0,     0,     0,    29,    30,
       0,   174,   620,   176,    31,    32,    33,     0,   311,     0,
      34,    35,    36,     0,     0,    37,    38,    39,    40,    41,
     704,     0,     0,   328,    42,    43,    44,    45,     0,    46,
      47,    48,    49,    50,    51,    52,    53,     0,     0,     0,
      54,    55,     0,     0,    56,    57,    58,    59,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   311,   311,     0,     0,     0,     0,     0,
     624,     0,     0,   311,   311,     0,   311,     0,     0,     0,
       0,    60,    61,     0,   177,   178,   179,   180,   181,   182,
     311,     0,   311,     0,     0,     0,   780,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   792,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   328,   328,   328,   328,     0,     0,     0,
       0,     0,     0,   328,   797,     0,   798,     0,     0,   328,
       0,     0,     0,     0,   799,   800,   328,     0,   624,   328,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   819,   820,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   311,     0,
       0,     0,     0,     0,   311,   311,     0,     0,   311,     0,
       0,   311,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   311,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     309,     0,   311,   311,     0,   311,   311,     0,     0,   328,
     328,     0,     0,   328,     0,   328,   328,   328,   328,     0,
       0,     0,     0,   311,     0,     0,   624,   624,   624,   624,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     624,   624,   624,     0,   624,     0,     0,     0,     0,     0,
     372,     0,     0,   328,   328,     0,   328,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   311,   311,   311,   311,     0,     0,   311,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1153,     0,   328,     0,     0,     0,     0,   328,     0,     0,
       0,     0,     0,     0,  1004,     0,     0,     0,     0,   328,
     328,     0,     0,     0,     0,     0,   311,   311,   311,   311,
       0,   311,   311,   311,  1176,     0,     0,     0,     0,     0,
       0,     0,     0,   328,     0,     0,     0,     0,   624,   311,
     311,   328,     0,     0,     0,   472,   328,     0,     0,     0,
     328,   624,     0,     0,   624,     0,     0,   624,     0,     0,
     624,     0,     0,     0,     0,     0,     0,     0,   998,     0,
     624,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   311,     0,
     311,   311,   311,     0,   311,     0,     0,     0,   529,   311,
     311,     0,     0,     0,     0,     0,     0,   537,   538,     0,
     540,     0,     0,     0,     0,     0,     0,     0,   311,     0,
       0,   311,   311,   311,   311,   311,   311,     0,     0,   311,
       0,     0,     0,   311,   311,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   998,     0,     0,     0,     0,
    1100,  1101,     0,     0,  1103,     0,  1104,     0,     0,   624,
     624,   624,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   311,     0,   311,     0,     0,     0,   311,   311,     0,
       0,   311,   311,     0,     0,     0,     0,   311,   311,   311,
     311,     0,   311,   311,     0,   311,   311,   311,   637,   998,
       0,     0,     0,     0,   998,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   624,     0,
     624,     0,     0,  1154,     0,     0,     0,   311,     0,     0,
       0,     0,   311,   311,   311,   311,     0,     0,     0,   311,
       0,   311,   311,     0,     0,   311,     0,     0,     0,   998,
       0,     0,     0,   680,   681,     0,     0,     0,     0,     0,
     688,     0,     0,   692,   693,     0,   695,     0,     0,     0,
       0,   311,   311,   311,   311,     0,     0,   311,   311,   311,
     706,     0,   707,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   311,   311,     0,
       0,   311,   311,     0,   311,     0,   998,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   311,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   311,   998,
       0,     0,     0,     0,     0,     0,     0,     0,   311,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    13,    14,    15,    16,    17,
      18,    19,    20,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    21,     0,     0,    22,    23,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   804,    24,
       0,    25,   392,     0,   808,   809,     0,     0,   812,     0,
       0,   814,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   823,     0,     0,     0,    26,     0,     0,     0,
       0,     0,    27,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   850,   851,     0,   852,   853,     0,    29,    30,
       0,     0,     0,     0,    31,    32,    33,     0,     0,     0,
      34,    35,    36,   873,     0,    37,    38,    39,    40,    41,
       0,     0,     0,     0,    42,    43,    44,    45,     0,    46,
      47,    48,    49,    50,    51,    52,    53,     0,     0,     0,
      54,    55,     0,     0,    56,    57,    58,    59,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   923,   924,   925,   926,     0,     0,   928,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    60,    61,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   953,   954,   955,   956,
       0,   958,   959,   960,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   966,   967,
     968,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1012,     0,
    1013,  1014,  1015,     0,  1017,     0,     0,     0,     0,  1021,
    1022,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1031,     0,
       0,  1032,  1033,  1034,  1035,  1036,  1037,     0,     0,  1039,
       0,     0,     0,  1041,  1042,     0,     0,     0,     0,     0,
       0,     0,   199,     0,   204,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   218,   219,   220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1070,     0,  1072,     0,     0,     0,  1074,  1075,     0,
       0,  1078,  1079,     0,     0,     0,     0,  1081,  1082,  1083,
    1084,     0,  1085,  1086,     0,  1088,  1089,  1090,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1113,     0,     0,
       0,     0,  1115,  1116,  1117,  1118,     0,     0,     0,  1119,
       0,  1120,  1121,     0,     0,  1124,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1141,  1142,  1143,  1144,     0,     0,  1145,  1146,  1147,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1158,  1159,     0,
       0,  1160,  1161,     0,  1147,   359,   360,   361,     0,     0,
     363,     0,     0,   366,     0,     0,  1171,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1147,     0,
       0,     0,     0,   386,   387,     0,     0,     0,  1185,     0,
       0,     0,   390,     0,     0,     0,     0,   395,   396,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   415,   416,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   426,   427,
     429,   430,     0,     0,     0,     0,     0,   438,   439,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   241,     0,     0,     0,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    -8,    -8,    -8,    -8,    -8,    -8,     0,     0,     0,
       0,     0,    -8,    -8,     0,     0,    -8,    -8,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    -8,     0,    -8,    -8,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,     0,
       0,     0,   584,   585,     0,   588,     0,   590,    -8,     0,
       0,     0,   595,     1,    -8,   598,     0,     0,     0,     0,
       0,   603,     0,     0,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,     0,     0,     0,     0,     0,     0,     0,    -8,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    13,    14,    15,    16,    17,
      18,    19,    20,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    21,     0,     0,    22,    23,     0,     0,     0,     0,
       0,   739,     0,   741,     0,     0,   744,   745,     0,    24,
       0,    25,     0,     0,     0,   754,   755,     0,     0,     0,
     758,     0,   760,   761,   762,   763,     0,   766,   767,   768,
     769,     0,   775,   776,     0,     0,    26,     0,     0,   778,
     779,     0,    27,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   243,   244,   245,   246,   247,   248,    29,    30,
       0,     0,     0,   249,    31,    32,    33,     0,     0,     0,
      34,    35,    36,     0,     0,    37,    38,    39,    40,    41,
       0,     0,     0,     0,    42,    43,    44,    45,     0,    46,
      47,    48,    49,    50,    51,    52,    53,     0,     0,     0,
      54,    55,     0,     0,    56,    57,    58,    59,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   829,
     830,     0,     0,     0,     0,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,    60,    61,   265,   266,   267,   268,     0,     0,     0,
     269,   270,   271,     0,     0,     0,   272,   273,     0,     0,
       0,     0,     0,   274,   275,   276,   277,     0,     0,     0,
       0,   278,     0,     0,     0,     0,     0,     0,     0,     0,
     279,   280,   281,     0,     0,   282,   283,     0,     0,     0,
       0,   284,     0,     0,     0,     0,     0,     0,     0,   285,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,     0,     0,     0,     0,     0,     0,
       0,   935,   936,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   952,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   962
};

static const yytype_int16 yycheck[] =
{
      22,    23,   453,   345,   491,   492,   493,   464,   898,   898,
     199,   489,   490,   220,    62,    16,   559,   207,    19,   219,
     378,   766,   245,   246,   247,   248,   183,   387,   768,    59,
     355,  1093,   498,   822,   896,   897,    59,   902,   902,    59,
    1124,    42,     8,   779,    59,   349,    73,    59,     1,   617,
       3,    78,   359,   621,    42,    43,    71,    49,    40,    64,
     217,    76,    77,     1,    87,    88,    89,    87,    54,    55,
      49,    59,    87,    88,    89,    91,   542,  1161,    87,    88,
      89,    93,    87,    46,    36,    37,    38,    39,  1150,    52,
      59,    64,   982,    79,    80,    59,    62,    70,    58,    65,
      67,    68,   761,   762,    66,    72,    59,    71,   415,   416,
       0,    73,    76,    77,   979,    57,   775,   776,    71,   778,
      91,    73,    64,    76,    77,    57,    90,    87,    88,    89,
     875,    62,    64,    64,    87,    87,    88,    89,   878,   189,
     190,   877,   172,   485,   486,   487,   488,    48,    49,    87,
      88,    89,   359,   343,    87,   900,    89,   172,   173,   174,
     175,   612,   184,   172,    13,   901,    16,   903,    54,  1058,
      20,   628,   629,    59,   397,   398,   399,   400,  1043,  1043,
      54,   163,   204,  1048,  1048,    59,   544,   169,   977,   379,
     390,   516,   981,   215,   384,   499,   218,   765,   766,   541,
     768,   183,   359,   172,   173,   174,   175,    49,   172,   173,
     174,   175,   189,   190,    54,    55,   198,   199,  1108,   172,
     173,   174,   175,    60,   172,    54,   885,    64,  1093,   888,
      59,   213,   891,    63,   216,   217,  1098,   219,   220,    79,
      80,   223,    70,    71,    46,   904,    48,    49,  1091,    60,
      52,   233,   172,    64,  1097,    83,    84,    85,   415,   416,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,    46,    90,    48,    49,    50,
      51,    52,   825,   826,    60,  1150,   829,   830,    64,  1151,
    1152,   598,    60,  1183,  1183,  1138,    64,    59,  1188,  1188,
      60,    63,  1192,  1192,    64,   189,   190,   875,  1173,  1173,
     878,    59,   763,  1175,    36,    37,    38,    39,    87,    88,
      89,    60,   344,   774,   666,    64,    87,   784,   785,   872,
      87,    87,   900,    90,    87,   994,   526,    59,   360,   361,
     563,   564,   565,   566,  1187,   393,   189,   190,  1191,    71,
      87,    73,    59,  1196,    76,    77,    87,    88,    89,    77,
     382,   568,   569,   385,    71,    87,    88,    89,    53,    76,
      77,    59,    95,   355,    63,   582,   355,   359,    97,    59,
      96,   363,   364,    71,   189,   190,   368,   369,    76,    77,
      59,    71,   935,   936,   937,   938,    76,    77,    97,   381,
     382,    59,    90,    90,   386,   387,   388,   429,   390,   598,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   426,   172,   393,    21,    22,
      23,    24,    25,   415,   416,    48,    49,    50,   439,   189,
     190,   598,   101,   894,    87,    88,    89,   101,   170,   171,
     172,   173,   174,   175,   182,   183,   184,   185,   186,   183,
     184,   185,    97,   170,   171,   172,   173,   174,   175,    81,
      82,   453,    48,    49,    64,    65,    70,    71,   500,    97,
    1023,  1024,   179,   180,   172,   173,   174,   175,    70,    71,
     713,   714,   172,   173,   174,   175,    70,    71,   280,   281,
     699,   700,   524,   525,    87,   483,   484,    87,   530,   531,
     870,   871,   719,   355,   721,    35,    97,   539,    17,    69,
      54,    59,   172,    59,   516,    98,   172,   187,    63,    97,
      97,     4,   514,    97,    63,   557,    97,   516,     4,     4,
      28,    94,   993,   750,   995,    63,   190,   189,   189,  1006,
     532,   190,   534,   535,   190,    47,    18,    18,    18,    18,
      60,   751,   584,   585,    20,    59,    64,   559,    63,   911,
      63,   553,  1059,   595,    60,    87,   918,    74,    54,   921,
     559,    59,  1060,   169,    75,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   791,   172,    54,   964,    59,   588,    64,   590,    64,
     188,  1062,   172,  1064,   173,   173,   598,  1095,  1096,    63,
     172,   603,    63,    87,    26,    97,    97,   172,   835,   172,
     612,   177,    18,    61,    16,   172,    36,    37,    38,    39,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    60,   637,   678,   679,    58,    59,
      64,   172,   684,   685,   686,    60,    56,    59,   690,   278,
     172,    71,    60,    73,   516,    59,    76,    77,  1038,    59,
      63,    62,   172,   172,    27,   172,   708,    87,    88,    89,
     172,   172,   172,   172,   177,   717,   718,    19,   720,    60,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,    87,    60,    57,    65,   559,    55,   172,
     742,    60,    60,    64,    60,   172,   172,  1087,    97,    64,
     172,    59,   754,   755,   172,   172,   172,   719,    59,   721,
     203,    59,   182,    56,    56,    15,    69,    87,   170,   171,
     172,   173,    60,    55,    64,    60,    57,    54,   172,   741,
      60,   181,   744,   745,    56,    56,    56,   749,   750,    56,
     170,   171,   172,   173,   174,   175,   758,    14,   760,   761,
     762,   763,    60,   805,    60,    64,    57,    54,   810,    55,
      55,   813,   774,   775,   776,    72,   778,  1139,    57,   172,
      64,    64,   824,   178,    59,   100,    60,    64,    60,   831,
      60,    57,   834,    64,   836,   837,   838,   839,   840,    57,
      64,   843,    64,   845,   846,   847,   848,   178,    64,    60,
      57,    55,   854,   825,   826,    64,    57,   829,   830,    64,
      60,    99,    64,    57,   178,    64,   825,   826,    64,    57,
     829,   830,    57,   835,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,    57,   454,   455,    57,   239,
     242,   160,   631,   303,   560,   913,   425,   879,   878,   301,
     872,   981,   304,   894,    36,    37,    38,    39,   870,   871,
     765,   774,   314,   872,   598,   750,   366,   382,   171,   171,
     795,   470,   479,   885,    -1,   927,   888,    59,   342,   891,
     932,   482,   894,   895,   896,   897,   898,   939,   480,    71,
     942,   943,   904,   345,    76,    77,   348,   949,   355,    -1,
     481,    -1,   390,   194,    -1,    87,    88,    89,    -1,    -1,
     962,    -1,    -1,   935,   936,   937,   938,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   935,   936,   937,   938,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    36,    37,    38,    39,    -1,    -1,
      -1,    -1,   964,   825,   826,    -1,    -1,   829,   830,   170,
      -1,    -1,    -1,    -1,  1016,    -1,    58,    59,  1020,    -1,
     982,    -1,    -1,    -1,    -1,    -1,    -1,  1029,    -1,    71,
      -1,   993,   994,   995,    76,    77,    -1,    -1,   170,   171,
     172,   173,   174,   175,    -1,    87,    88,    89,    -1,    -1,
     872,  1023,  1024,    -1,    -1,   457,   458,   459,   460,    -1,
      -1,   463,    -1,    -1,  1023,  1024,    -1,    -1,    -1,    -1,
     164,  1073,    -1,    -1,   476,   477,  1038,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,    -1,    -1,    -1,    -1,    -1,
    1062,    -1,  1064,    -1,  1066,    -1,    -1,    -1,   510,    -1,
      -1,    -1,  1114,   935,   936,   937,   938,    -1,    -1,    -1,
     214,   523,    -1,    -1,    -1,  1087,    -1,    -1,   170,   171,
     172,   173,   174,   175,    -1,    -1,  1098,    -1,    -1,   541,
     301,    -1,    -1,   304,    -1,    -1,  1108,    -1,    -1,   551,
      -1,    -1,    -1,    -1,    -1,  1157,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   345,    -1,    -1,   348,    -1,  1151,
    1152,    -1,    -1,    -1,    36,    37,    38,    39,    -1,    -1,
      -1,  1023,  1024,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1175,    -1,   309,    58,    59,    -1,    -1,
      -1,  1183,    -1,    -1,    -1,   627,  1188,    -1,    -1,    71,
    1192,    -1,    -1,    -1,    76,    77,   638,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    88,    89,    -1,    -1,
       0,    -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      10,    11,    12,   665,   666,   667,    -1,    -1,   362,    -1,
      -1,    -1,    -1,   675,   676,    -1,    -1,   371,   372,    -1,
     374,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    -1,    -1,    44,    45,   457,   458,   459,   460,
     702,   703,   463,    -1,    -1,    -1,    -1,    -1,    -1,    59,
      -1,    61,    62,    -1,    -1,   476,   477,    -1,    -1,    -1,
      36,    37,    38,    39,    -1,    -1,    -1,    -1,   170,   171,
     172,   173,   174,   175,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    91,    92,    59,    -1,    -1,    -1,    -1,    -1,   510,
      -1,    -1,   102,    -1,    -1,    71,    -1,    -1,    -1,   453,
      76,    77,   523,    -1,    -1,    -1,    -1,    -1,   118,   119,
      -1,    87,    88,    89,   124,   125,   126,    -1,   472,    -1,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
     551,    -1,    -1,   795,   144,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,    -1,    -1,    -1,
     160,   161,    -1,    -1,   164,   165,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   527,   528,    -1,    -1,    -1,    -1,    -1,
     534,    -1,    -1,   537,   538,    -1,   540,    -1,    -1,    -1,
      -1,   201,   202,    -1,   170,   171,   172,   173,   174,   175,
     554,    -1,   556,    -1,    -1,    -1,   627,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   638,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   895,   896,   897,   898,    -1,    -1,    -1,
      -1,    -1,    -1,   905,   665,    -1,   667,    -1,    -1,   911,
      -1,    -1,    -1,    -1,   675,   676,   918,    -1,   612,   921,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   702,   703,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   682,    -1,
      -1,    -1,    -1,    -1,   688,   689,    -1,    -1,   692,    -1,
      -1,   695,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     164,    -1,   736,   737,    -1,   739,   740,    -1,    -1,  1051,
    1052,    -1,    -1,  1055,    -1,  1057,  1058,  1059,  1060,    -1,
      -1,    -1,    -1,   757,    -1,    -1,   760,   761,   762,   763,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     774,   775,   776,    -1,   778,    -1,    -1,    -1,    -1,    -1,
     214,    -1,    -1,  1095,  1096,    -1,  1098,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   806,   807,   808,   809,    -1,    -1,   812,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1132,    -1,  1134,    -1,    -1,    -1,    -1,  1139,    -1,    -1,
      -1,    -1,    -1,    -1,   905,    -1,    -1,    -1,    -1,  1151,
    1152,    -1,    -1,    -1,    -1,    -1,   850,   851,   852,   853,
      -1,   855,   856,   857,  1166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1175,    -1,    -1,    -1,    -1,   872,   873,
     874,  1183,    -1,    -1,    -1,   309,  1188,    -1,    -1,    -1,
    1192,   885,    -1,    -1,   888,    -1,    -1,   891,    -1,    -1,
     894,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   902,    -1,
     904,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   922,    -1,
     924,   925,   926,    -1,   928,    -1,    -1,    -1,   362,   933,
     934,    -1,    -1,    -1,    -1,    -1,    -1,   371,   372,    -1,
     374,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   952,    -1,
      -1,   955,   956,   957,   958,   959,   960,    -1,    -1,   963,
      -1,    -1,    -1,   967,   968,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   979,    -1,    -1,    -1,    -1,
    1051,  1052,    -1,    -1,  1055,    -1,  1057,    -1,    -1,   993,
     994,   995,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1015,    -1,  1017,    -1,    -1,    -1,  1021,  1022,    -1,
      -1,  1025,  1026,    -1,    -1,    -1,    -1,  1031,  1032,  1033,
    1034,    -1,  1036,  1037,    -1,  1039,  1040,  1041,   472,  1043,
      -1,    -1,    -1,    -1,  1048,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1062,    -1,
    1064,    -1,    -1,  1134,    -1,    -1,    -1,  1071,    -1,    -1,
      -1,    -1,  1076,  1077,  1078,  1079,    -1,    -1,    -1,  1083,
      -1,  1085,  1086,    -1,    -1,  1089,    -1,    -1,    -1,  1093,
      -1,    -1,    -1,   527,   528,    -1,    -1,    -1,    -1,    -1,
     534,    -1,    -1,   537,   538,    -1,   540,    -1,    -1,    -1,
      -1,  1115,  1116,  1117,  1118,    -1,    -1,  1121,  1122,  1123,
     554,    -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1141,  1142,    -1,
      -1,  1145,  1146,    -1,  1148,    -1,  1150,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1160,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1172,  1173,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1182,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   682,    59,
      -1,    61,    62,    -1,   688,   689,    -1,    -1,   692,    -1,
      -1,   695,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   706,    -1,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    -1,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   736,   737,    -1,   739,   740,    -1,   118,   119,
      -1,    -1,    -1,    -1,   124,   125,   126,    -1,    -1,    -1,
     130,   131,   132,   757,    -1,   135,   136,   137,   138,   139,
      -1,    -1,    -1,    -1,   144,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,    -1,    -1,    -1,
     160,   161,    -1,    -1,   164,   165,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   806,   807,   808,   809,    -1,    -1,   812,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   201,   202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   850,   851,   852,   853,
      -1,   855,   856,   857,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   872,   873,
     874,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   922,    -1,
     924,   925,   926,    -1,   928,    -1,    -1,    -1,    -1,   933,
     934,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   952,    -1,
      -1,   955,   956,   957,   958,   959,   960,    -1,    -1,   963,
      -1,    -1,    -1,   967,   968,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    -1,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1015,    -1,  1017,    -1,    -1,    -1,  1021,  1022,    -1,
      -1,  1025,  1026,    -1,    -1,    -1,    -1,  1031,  1032,  1033,
    1034,    -1,  1036,  1037,    -1,  1039,  1040,  1041,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1071,    -1,    -1,
      -1,    -1,  1076,  1077,  1078,  1079,    -1,    -1,    -1,  1083,
      -1,  1085,  1086,    -1,    -1,  1089,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1115,  1116,  1117,  1118,    -1,    -1,  1121,  1122,  1123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1141,  1142,    -1,
      -1,  1145,  1146,    -1,  1148,   201,   202,   203,    -1,    -1,
     206,    -1,    -1,   209,    -1,    -1,  1160,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1172,    -1,
      -1,    -1,    -1,   229,   230,    -1,    -1,    -1,  1182,    -1,
      -1,    -1,   238,    -1,    -1,    -1,    -1,   243,   244,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   263,   264,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,   275,
     276,   277,    -1,    -1,    -1,    -1,    -1,   283,   284,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    29,    30,    31,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    40,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    59,    -1,    61,    62,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
      -1,    -1,   418,   419,    -1,   421,    -1,   423,    86,    -1,
      -1,    -1,   428,    91,    92,   431,    -1,    -1,    -1,    -1,
      -1,   437,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    -1,
      -1,   587,    -1,   589,    -1,    -1,   592,   593,    -1,    59,
      -1,    61,    -1,    -1,    -1,   601,   602,    -1,    -1,    -1,
     606,    -1,   608,   609,   610,   611,    -1,   613,   614,   615,
     616,    -1,   618,   619,    -1,    -1,    86,    -1,    -1,   625,
     626,    -1,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    29,    30,    31,    32,    33,    34,   118,   119,
      -1,    -1,    -1,    40,   124,   125,   126,    -1,    -1,    -1,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,    -1,    -1,    -1,   144,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,    -1,    -1,    -1,
     160,   161,    -1,    -1,   164,   165,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   715,
     716,    -1,    -1,    -1,    -1,    -1,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   201,   202,   120,   121,   122,   123,    -1,    -1,    -1,
     127,   128,   129,    -1,    -1,    -1,   133,   134,    -1,    -1,
      -1,    -1,    -1,   140,   141,   142,   143,    -1,    -1,    -1,
      -1,   148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     157,   158,   159,    -1,    -1,   162,   163,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   827,   828,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   849,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   869
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    91,   205,   208,   209,     0,    91,    13,   206,   217,
     172,   209,    63,     5,     6,     7,     8,     9,    10,    11,
      12,    41,    44,    45,    59,    61,    86,    92,   102,   118,
     119,   124,   125,   126,   130,   131,   132,   135,   136,   137,
     138,   139,   144,   145,   146,   147,   149,   150,   151,   152,
     153,   154,   155,   156,   160,   161,   164,   165,   166,   167,
     201,   202,   207,   210,   211,   212,   215,   216,   218,   219,
     220,   221,   222,   223,   225,   226,   227,   230,   231,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   263,   264,   265,   266,   267,   268,   269,
     271,   272,   274,   277,   278,   280,   281,   283,   285,   286,
     287,   288,   289,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   325,   326,
     327,   330,   332,   333,   334,   335,   336,   337,   338,   339,
     341,   407,   172,    87,    87,    90,   214,    90,   214,    87,
      87,   214,    87,    59,   388,    36,    37,    38,    39,    58,
      59,    71,    76,    77,    87,    88,    89,   170,   171,   172,
     173,   174,   175,   345,   352,   357,   373,   374,   375,   376,
     377,   381,   390,   391,   403,   404,   352,    77,   342,   388,
      53,   346,    42,    43,   388,    96,   340,    95,    63,   387,
      97,    97,    59,   359,   390,    59,   360,   214,   388,   388,
     388,    90,   172,   345,   353,   357,   374,   101,   101,    97,
      97,    87,    87,    97,   189,   190,   306,    35,   344,   208,
     209,     1,   209,    29,    30,    31,    32,    33,    34,    40,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   120,   121,   122,   123,   127,
     128,   129,   133,   134,   140,   141,   142,   143,   148,   157,
     158,   159,   162,   163,   168,   176,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    21,    22,    23,    24,
      25,    17,   228,   228,    69,   172,   389,   390,    88,   363,
     364,   391,   384,   390,    71,   172,   173,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   173,
     375,   376,   403,   403,   403,    48,    49,    48,    49,    50,
      59,    87,   381,   390,   352,    54,   379,   380,    59,   382,
      46,    52,   406,   383,   390,   347,   367,   385,   390,   388,
     388,   388,   352,   388,   382,   172,   388,    59,   386,    98,
     172,   390,   363,   352,   390,   349,   368,   369,   381,   390,
     352,   348,   362,   368,   390,   383,   388,   388,   390,   187,
     388,   210,    62,   207,   213,   388,   388,   387,   387,   387,
     387,   344,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   344,   344,   344,   344,   388,   388,    63,    97,    97,
       4,    97,    63,    97,     4,     4,   388,   388,    93,   388,
     388,   344,    28,   279,   279,   279,    94,   284,   388,   388,
      63,   189,   190,   189,   189,   190,   189,   190,   189,   189,
     190,   189,   190,   190,   190,   190,    47,    18,    18,    18,
      18,   392,    16,    20,   229,   237,   229,    90,   392,    60,
      64,    63,   363,    63,   365,    57,    64,    59,    60,    73,
      78,    74,    75,    81,    82,    54,    55,    79,    80,    70,
      71,    83,    84,    85,    67,    68,    72,    87,   380,   382,
     352,   392,   399,    48,    49,    50,    51,   405,   406,   392,
      54,   379,   169,   343,    73,   355,   356,   357,   370,   371,
     372,   385,   390,    59,   349,   383,   390,   352,   352,   363,
     390,   390,   340,   172,   390,   390,    64,   363,   363,    64,
     363,    54,   378,   378,   382,    59,   361,   390,   352,   361,
     390,    59,   352,    59,   273,   390,   273,   390,   188,   348,
     209,   173,   173,   387,   387,   387,   387,   388,   388,   388,
     388,   388,   388,   388,   388,   388,   388,   388,   388,   388,
     388,   349,   349,   172,   388,   388,    63,   290,   388,   172,
     388,    63,   270,   270,   214,   388,   352,    87,   388,    26,
     275,    97,    97,   388,   172,   214,   172,   177,   307,   307,
     307,   307,   307,   307,   307,   307,   307,   307,   307,   307,
      88,   323,   363,   390,   391,   307,   307,    18,   392,   392,
     392,   392,    61,   392,   237,   389,   172,   363,    59,   172,
     392,   392,   395,   394,   396,   397,   398,   398,   399,   399,
     399,   399,   402,   402,   401,   401,   401,   403,   403,   403,
      60,   405,   379,   352,    64,    65,    55,    64,   392,    60,
     390,   354,   357,   370,   374,    56,    59,   392,   352,   352,
     363,   363,   352,   172,   262,   352,   390,    60,   363,   390,
     390,   172,   363,   363,   352,   363,   399,   405,   378,    64,
      87,   331,    59,    59,   392,   390,   363,   363,   352,   353,
     213,   172,   172,   387,   387,   387,   387,   349,   349,   383,
     349,   383,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   383,    63,   352,   352,   172,   388,
     390,   388,   390,   172,   388,   388,   352,   172,   172,   347,
     349,   390,    27,   276,   388,   388,   390,   172,   388,   177,
     388,   388,   388,   388,   323,   329,   388,   388,   388,   388,
     183,   184,   185,   317,   328,   388,   388,   317,   388,   388,
     392,   237,   237,    19,   224,   224,    87,   235,   236,    60,
     358,   390,   392,    57,    60,    66,   172,   392,   392,   392,
     392,    60,   352,   352,   363,   352,   352,   352,   363,   363,
     352,    60,   363,    64,   363,    55,   331,   331,    60,   392,
     392,    60,    64,   363,   352,   172,   172,   387,   387,   388,
     388,   352,   352,   383,   352,   383,   352,   352,   352,   352,
     352,   352,   352,   352,   352,   352,   352,   352,   352,   172,
     363,   363,   363,   363,   390,   352,   390,   390,   172,   172,
     172,   350,   351,   352,   370,   372,   350,   383,   390,    97,
     352,   352,   282,   363,   390,   321,   323,   321,   321,   322,
     323,   203,   328,   182,   186,   308,   316,   317,   313,   317,
     308,   309,   316,   182,   310,    59,    59,    59,    56,   329,
     321,   321,    56,   321,   313,    15,   232,   233,    87,   237,
     237,    69,    62,    64,   382,    60,   393,    55,    64,    60,
      57,    54,   352,   363,   363,   363,   363,   352,   363,   352,
      60,   404,   352,   353,   353,   388,   388,   353,   353,   352,
     352,   383,   352,   352,   352,   352,   352,   352,   352,   352,
     352,   352,   388,   363,   363,   363,   363,   352,   363,   363,
     363,   172,   388,   273,   273,   353,   363,   363,   363,   308,
     179,   180,   313,   309,   310,   181,   321,    56,   321,    56,
     321,    56,    56,   322,   318,   319,   320,   390,   392,   318,
     318,   319,   320,   308,   317,   313,   324,   364,   391,   313,
     321,     1,     3,    87,   392,    14,   234,    90,   399,   235,
     399,   399,   363,   363,   363,   363,   352,   363,    60,    60,
     352,   363,   363,   353,   353,   353,   353,   352,   352,   352,
     352,   363,   363,   363,   363,   363,   363,   363,   352,   363,
     273,   363,   363,   315,   404,   311,   312,   324,   315,   320,
      60,    64,    59,    63,    60,    64,    60,    64,    64,    70,
      71,   314,   323,   321,   323,    57,    54,   237,    55,    55,
     363,   352,   363,   352,   363,   363,   353,   353,   363,   363,
     352,   363,   363,   363,   363,   363,   363,   273,   363,   363,
     363,   324,    72,    64,    57,    70,    71,   324,    64,    70,
     392,   392,   172,   392,   392,   319,   401,   402,    64,   323,
     323,     1,   390,   363,   352,   363,   363,   363,   363,   363,
     363,   363,   273,   366,   363,   314,   311,   178,   402,   402,
     314,   318,    59,    60,    64,    60,    60,    57,   320,    64,
     352,   363,   363,   363,   363,   363,   363,   363,   366,    57,
      64,    64,    64,   403,   392,   314,   399,   100,   363,   363,
     363,   363,   178,   311,   318,   318,    64,    60,    57,    55,
     352,   363,   366,    64,    57,    64,   403,    99,   324,   178,
     318,    60,   352,    64,    57,   363,   319,   320,    64,   314,
     319,   320,    64,    57,   314,   319,   320,    57,    57,   314,
      57
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   204,   205,   206,   207,   207,   208,   208,   209,   209,
     210,   210,   210,   210,   210,   210,   210,   210,   210,   210,
     210,   211,   211,   211,   212,   213,   214,   214,   215,   216,
     217,   218,   218,   218,   218,   218,   218,   219,   220,   221,
     222,   223,   224,   224,   225,   226,   226,   227,   227,   228,
     228,   229,   230,   230,   230,   230,   231,   232,   232,   233,
     233,   233,   233,   234,   234,   234,   235,   235,   235,   236,
     236,   237,   237,   238,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   239,   240,   240,   240,   240,
     241,   241,   242,   243,   244,   245,   245,   246,   246,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   257,   257,   258,   259,   259,   259,   260,   260,   261,
     261,   262,   263,   264,   265,   266,   267,   267,   267,   267,
     267,   267,   268,   269,   270,   270,   271,   272,   272,   273,
     273,   274,   275,   275,   276,   276,   277,   278,   279,   279,
     280,   281,   282,   282,   282,   283,   284,   284,   285,   286,
     287,   287,   287,   288,   289,   289,   289,   289,   289,   289,
     289,   290,   290,   291,   291,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   306,   307,   307,   308,   309,   309,   310,   310,
     310,   310,   310,   311,   311,   311,   312,   312,   312,   312,
     313,   314,   314,   314,   315,   315,   316,   316,   316,   316,
     317,   317,   317,   317,   317,   317,   318,   318,   319,   320,
     320,   320,   321,   321,   322,   323,   323,   324,   324,   325,
     325,   325,   326,   327,   328,   328,   329,   330,   331,   331,
     331,   332,   332,   332,   332,   332,   332,   332,   332,   333,
     334,   335,   335,   336,   337,   338,   338,   338,   338,   339,
     339,   339,   339,   339,   339,   339,   339,   340,   340,   341,
     341,   342,   342,   343,   343,   344,   344,   345,   345,   345,
     345,   346,   346,   347,   348,   349,   349,   350,   350,   351,
     351,   352,   352,   352,   353,   353,   354,   354,   354,   355,
     355,   356,   356,   357,   358,   359,   360,   361,   362,   363,
     363,   364,   365,   365,   366,   366,   367,   368,   368,   369,
     370,   370,   371,   372,   373,   373,   374,   374,   374,   374,
     374,   374,   375,   375,   375,   376,   376,   376,   377,   377,
     378,   379,   380,   380,   380,   381,   381,   382,   383,   384,
     385,   386,   386,   387,   388,   388,   389,   390,   390,   391,
     391,   392,   393,   393,   394,   394,   395,   395,   396,   396,
     397,   397,   397,   398,   398,   398,   398,   398,   399,   400,
     400,   400,   400,   401,   401,   401,   402,   402,   402,   402,
     403,   403,   403,   403,   404,   404,   404,   404,   404,   404,
     405,   405,   405,   405,   405,   406,   406,   407
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     5,     1,     3,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     2,     1,     1,     1,     1,     2,     2,
       4,     1,     1,     1,     1,     1,     1,     2,     9,     6,
       6,     7,     0,     2,     7,     4,     3,     5,     4,     0,
       2,     2,     4,     4,     2,     3,     2,     0,     1,     2,
       2,     2,     2,     0,     6,     3,     3,     3,     1,     3,
       1,     0,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     7,     7,     8,     9,
       6,     6,     6,     7,     6,     7,     6,     8,     7,     7,
       6,     8,     8,     5,     6,     5,     4,     7,     7,     7,
       6,     6,     6,     1,     4,     4,     4,     6,     6,     8,
       7,     1,     8,    10,     8,     9,     1,     1,     1,     5,
       3,     2,    10,    13,     0,     2,    10,     9,     8,     1,
       5,    13,     0,     1,     0,     1,    10,    11,     0,     1,
       6,     5,     0,     2,     2,     6,     0,     1,     9,    16,
       9,     5,     6,     6,     5,     5,     4,     9,     9,     7,
       7,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     7,     7,     7,
       7,     7,     7,     9,     7,     7,     7,     7,     9,     8,
       4,     1,     1,     0,     2,     7,     9,     1,    16,    14,
      15,    15,    10,     1,     3,     3,     1,     3,     5,     7,
       5,     0,     2,     2,     0,     2,     0,     1,     1,     1,
       4,     6,     4,     6,     4,     6,     1,     1,     1,     1,
       3,     6,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     6,     6,     6,     8,     2,     8,     0,     2,
       2,     4,     4,     3,     6,     6,     6,     7,     3,     2,
       2,     9,     9,     2,     2,    12,    12,    11,    11,     1,
       2,     1,     1,     2,     1,     2,     1,     0,     1,     0,
       5,     0,     1,     0,     1,     0,     1,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     5,     7,     4,     4,     1,
       3,     2,     2,     4,     0,     2,     1,     3,     2,     3,
       1,     4,     2,     1,     3,     4,     2,     2,     1,     2,
       1,     2,     1,     2,     2,     1,     2,     2,     3,     4,
       3,     7,     1,     5,     3,     5,     3,     5,     1,     4,
       7,     0,     3,     2,     3,     5,     1,     1,     1,     1,
       1,     1,     5,     1,     3,     1,     3,     1,     3,     1,
       3,     3,     1,     3,     3,     3,     3,     1,     1,     3,
       3,     3,     1,     3,     3,     1,     3,     3,     3,     1,
       2,     2,     2,     1,     1,     1,     3,     2,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (pBuilder, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, pBuilder); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (pBuilder);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, pBuilder);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, CISA_IR_Builder* pBuilder)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], pBuilder);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pBuilder); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, CISA_IR_Builder* pBuilder)
{
  YY_USE (yyvaluep);
  YY_USE (pBuilder);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (CISA_IR_Builder* pBuilder)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (pBuilder);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Listing: NewlinesOpt ListingHeader NewlinesOpt Statements NewlinesOpt  */
#line 673 "CISA.y"
                                                                      {
        TRACE("** Listing Complete\n");
        pBuilder->CISA_post_file_parse();
    }
#line 3116 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 23: /* Scope: ScopeStart error  */
#line 703 "CISA.y"
                       {
        PARSE_ERROR_AT((int)(yyvsp[-1].intval), "unclosed scope");
    }
#line 3124 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 24: /* ScopeStart: LBRACE  */
#line 707 "CISA.y"
           {
        pBuilder->CISA_push_decl_scope();
        (yyval.intval) = CISAlineno;
    }
#line 3133 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 25: /* ScopeEnd: RBRACE  */
#line 711 "CISA.y"
                 {pBuilder->CISA_pop_decl_scope();}
#line 3139 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 28: /* DirectiveKernel: DIRECTIVE_KERNEL IdentOrStringLit  */
#line 722 "CISA.y"
    {
        VISAKernel *cisa_kernel = NULL;
        pBuilder->AddKernel(cisa_kernel, (yyvsp[0].string));
    }
#line 3148 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 29: /* DirectiveGlobalFunction: DIRECTIVE_GLOBAL_FUNC IdentOrStringLit  */
#line 730 "CISA.y"
  {
      VISAFunction *cisa_kernel = NULL;
      pBuilder->AddFunction(cisa_kernel, (yyvsp[0].string));
  }
#line 3157 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 30: /* DirectiveVersion: DIRECTIVE_VERSION DEC_LIT DOT DEC_LIT  */
#line 738 "CISA.y"
   {
       pBuilder->CISA_IR_setVersion((unsigned char)(yyvsp[-2].intval), (unsigned char)(yyvsp[0].intval));
   }
#line 3165 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 37: /* DeclFunction: DIRECTIVE_FUNCDECL STRING_LIT  */
#line 752 "CISA.y"
    {
        // do nothing as it's informational only
    }
#line 3173 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 38: /* DeclVariable: DIRECTIVE_DECL IDENT V_TYPE_EQ_G DECL_DATA_TYPE NUM_ELTS_EQ IntExp AlignAttrOpt AliasAttrOpt GenAttrOpt  */
#line 759 "CISA.y"
    {
       ABORT_ON_FAIL(pBuilder->CISA_general_variable_decl(
           (yyvsp[-7].string), (unsigned int)(yyvsp[-3].intval), (yyvsp[-5].type), (yyvsp[-2].align), (yyvsp[-1].alias).aliasname, (yyvsp[-1].alias).offset, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
    }
#line 3183 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 39: /* DeclAddress: DIRECTIVE_DECL IDENT V_TYPE_EQ_A NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 767 "CISA.y"
   {
       ABORT_ON_FAIL(
           pBuilder->CISA_addr_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), ISA_TYPE_UW, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3193 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 40: /* DeclPredicate: DIRECTIVE_DECL IDENT V_TYPE_EQ_P NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 775 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_predicate_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3202 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 41: /* DeclSampler: DIRECTIVE_DECL IDENT V_TYPE_EQ_S NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 782 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_sampler_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), CISAlineno));
   }
#line 3210 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 42: /* VNameEqOpt: %empty  */
#line 785 "CISA.y"
                    {(yyval.string) = "";}
#line 3216 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 43: /* VNameEqOpt: V_NAME_EQ IDENT  */
#line 785 "CISA.y"
                                                 {(yyval.string) = (yyvsp[0].string);}
#line 3222 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 44: /* DeclSurface: DIRECTIVE_DECL IDENT V_TYPE_EQ_T NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 789 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_surface_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3231 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 45: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset InputSize  */
#line 797 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 3239 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 46: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset  */
#line 802 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-1].string), (short)(yyvsp[0].intval), (unsigned short)size, CISAlineno));
    }
#line 3250 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 47: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset InputSize GenAttrOpt  */
#line 814 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_implicit_input_directive(
            (yyvsp[-4].string), (yyvsp[-3].string), (short)(yyvsp[-2].intval), (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3259 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 48: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset GenAttrOpt  */
#line 821 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-2].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)size, CISAlineno));
    }
#line 3270 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 49: /* InputOffset: %empty  */
#line 828 "CISA.y"
                    {(yyval.intval) = 0;}
#line 3276 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 50: /* InputOffset: OFFSET_EQ IntExp  */
#line 828 "CISA.y"
                                                 {(yyval.intval) = (yyvsp[0].intval);}
#line 3282 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 51: /* InputSize: SIZE_EQ IntExp  */
#line 829 "CISA.y"
                          {(yyval.intval) = (yyvsp[0].intval);}
#line 3288 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 52: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS STRING_LIT  */
#line 835 "CISA.y"
                                                  {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-2].string), (yyvsp[0].string), CISAlineno));
    }
#line 3296 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 53: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS IntExp  */
#line 839 "CISA.y"
                                              {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directiveNum((yyvsp[-2].string), (uint32_t)(yyvsp[0].intval), CISAlineno));
    }
#line 3304 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 54: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT  */
#line 843 "CISA.y"
                                {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[0].string), nullptr, CISAlineno));
    }
#line 3312 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 55: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS  */
#line 847 "CISA.y"
                                       {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-1].string), nullptr, CISAlineno));
    }
#line 3320 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 56: /* DirectiveFunc: DIRECTIVE_FUNC IdentOrStringLit  */
#line 853 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_function_directive((yyvsp[0].string), CISAlineno));
    }
#line 3328 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 57: /* AlignAttrOpt: %empty  */
#line 858 "CISA.y"
                     {(yyval.align) = ALIGN_BYTE;}
#line 3334 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 59: /* Align: ALIGN_EQ ALIGN_KEYWORD  */
#line 860 "CISA.y"
                           { // 2GRF, 32word, ...
        (yyval.align) = (yyvsp[0].align);
    }
#line 3342 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 60: /* Align: ALIGN_EQ IDENT  */
#line 864 "CISA.y"
                   { // e.g. byte, word, dword, qword, GRF, GRFx2
       if (!ParseAlign(pBuilder, (yyvsp[0].string), (yyval.align))) {
           PARSE_ERROR((yyvsp[0].string), ": invalid align value");
       }
    }
#line 3352 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 61: /* Align: ALIGN_EQ IntExp  */
#line 870 "CISA.y"
                    {
        // e.g. %sizeof(GRF) or %sizeof(DECL)
        (yyval.align) = AlignBytesToVisaAlignment((int)(yyvsp[0].intval));
        if ((yyval.align) == ALIGN_UNDEF) {
            PARSE_ERROR("invalid align size (must be 1, 2, 4, 8, ..., 128)");
        }
    }
#line 3364 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 62: /* Align: ALIGN_EQ error  */
#line 878 "CISA.y"
                   {
        PARSE_ERROR("syntax error in align attribute");
    }
#line 3372 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 63: /* AliasAttrOpt: %empty  */
#line 885 "CISA.y"
    {
       (yyval.alias).aliasname = NULL;
       (yyval.alias).offset = 0;
    }
#line 3381 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 64: /* AliasAttrOpt: ALIAS_EQ LANGLE Var COMMA IntExpNRA RANGLE  */
#line 890 "CISA.y"
    {
       (yyval.alias).aliasname = (yyvsp[-3].string);
       (yyval.alias).offset = (int)(yyvsp[-1].intval);
    }
#line 3390 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 65: /* AliasAttrOpt: ALIAS_EQ LANGLE error  */
#line 895 "CISA.y"
    {
       PARSE_ERROR("syntax error in alias attribute");
    }
#line 3398 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 66: /* OneAttr: IDENT EQUALS IntExpNRA  */
#line 901 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), (yyvsp[0].intval), nullptr);
    }
#line 3406 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 67: /* OneAttr: IDENT EQUALS STRING_LIT  */
#line 905 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), 0, (yyvsp[0].string));
    }
#line 3414 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 68: /* OneAttr: IDENT  */
#line 909 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[0].string), 0, nullptr);
    }
#line 3422 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 69: /* AttrOpt: AttrOpt COMMA OneAttr  */
#line 915 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3430 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 70: /* AttrOpt: OneAttr  */
#line 920 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3438 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 71: /* GenAttrOpt: %empty  */
#line 926 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 3446 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 72: /* GenAttrOpt: ATTR_EQ LBRACE AttrOpt RBRACE  */
#line 930 "CISA.y"
    {
        (yyval.intval) = 1;
    }
#line 3454 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 125: /* Label: LABEL  */
#line 992 "CISA.y"
             {pBuilder->CISA_create_label((yyvsp[0].string), CISAlineno);}
#line 3460 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 126: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 997 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3469 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 127: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar PredVar  */
#line 1003 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].vISADecl), (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), CISAlineno);
    }
#line 3477 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 128: /* LogicInstruction: Predicate TERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1008 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3486 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 129: /* LogicInstruction: Predicate QUATERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1014 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-8].pred_reg), (yyvsp[-7].opcode), (yyvsp[-6].sat), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3495 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 130: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1021 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, NULL, CISAlineno);
    }
#line 3504 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 131: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar  */
#line 1027 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), NULL, CISAlineno);
    }
#line 3513 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 132: /* MathInstruction_2OPND: Predicate MATH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1034 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3522 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 133: /* MathInstruction_3OPND: Predicate MATH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1041 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3531 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 134: /* ArithInstruction_2OPND: Predicate ARITH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1048 "CISA.y"
    {
        pBuilder->CISA_create_arith_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3540 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 135: /* ArithInstruction_3OPND: Predicate ARITH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1055 "CISA.y"
    {
        MUST_HOLD(!(((yyvsp[-5].opcode) == ISA_LINE) && ((yyvsp[-1].genOperand).type == OPERAND_IMMEDIATE || (yyvsp[-1].genOperand).type == OPERAND_INDIRECT)),
            "wrong type of src0 operand");
        pBuilder->CISA_create_arith_instruction(
            (yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3552 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 136: /* ArithInstruction_3OPND: Predicate ARITH5_OP2 ExecSize VecDstOperand_G_I PredVar VecSrcOperand_G_I_IMM  */
#line 1065 "CISA.y"
    {
        pBuilder->CISA_create_arith_instruction2_predDst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, nullptr, CISAlineno);
    }
#line 3561 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 137: /* ArithInstruction_4OPND: Predicate ARITH4_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1074 "CISA.y"
     {
         pBuilder->CISA_create_arith_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3570 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 138: /* ArithInstruction_4OPND: Predicate ARITH4_OP2 ExecSize VecDstOperand_G_I VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1081 "CISA.y"
     {
        pBuilder->CISA_create_arith_instruction2((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3579 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 139: /* ArithInstruction_4OPND: Predicate ARITH5_OP2 ExecSize VecDstOperand_G_I PredVar VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1088 "CISA.y"
     {
        pBuilder->CISA_create_arith_instruction2_predDst((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3588 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 140: /* DpasInstruction: DPAS_OP ExecSize RawOperand RawOperand RawOperand VecSrcOpndSimple  */
#line 1097 "CISA.y"
    {
        pBuilder->CISA_create_dpas_instruction(
            (yyvsp[-5].dpas_info).opcode, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].genOperand).cisa_gen_opnd,
            (yyvsp[-5].dpas_info).src2Precision, (yyvsp[-5].dpas_info).src1Precision, (yyvsp[-5].dpas_info).depth, (yyvsp[-5].dpas_info).count, CISAlineno);
    }
#line 3599 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 141: /* BfnInstruction: Predicate BFN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1107 "CISA.y"
    {
        pBuilder->CISA_create_bfn_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].bfn_info).func_ctrl , (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3608 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 142: /* QwScatterInstruction: Predicate QW_SCATTER_OP DOT DEC_LIT ExecSize Var RawOperand RawOperand  */
#line 1113 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_qword_scatter_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (uint32_t)(yyvsp[-4].intval), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3617 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 143: /* FCvtInstruction: FCVT_OP SatModOpt ExecSize VecDstOperand_G VecSrcOperand_G_IMM  */
#line 1120 "CISA.y"
    {
        pBuilder->CISA_create_fcvt_instruction((yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3625 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 144: /* AntiTrigInstruction: Predicate ANTI_TRIG_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1126 "CISA.y"
    {
        pBuilder->CISA_create_invtri_inst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3634 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 145: /* AddrAddInstruction: ADDR_ADD_OP ExecSize VecDstOperand_A VecSrcOperand_G_A_AO VecSrcOperand_G_IMM_AO  */
#line 1135 "CISA.y"
    {
        // a grammatically problematic instruction
        //   addr_add (M1_NM, 1) A0(0)<1> &V127 - 0x10...
        //                                        ^^^^ next operand or V127 offset
        pBuilder->CISA_create_address_instruction((yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3646 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 146: /* SetpInstruction: SETP_OP ExecSize PredVar VecSrcOperand_G_I_IMM  */
#line 1145 "CISA.y"
    {
        pBuilder->CISA_create_setp_instruction(
            (yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3655 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 147: /* SelInstruction: Predicate SEL_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1152 "CISA.y"
    {
        pBuilder->CISA_create_sel_instruction((yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3664 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 148: /* MinInstruction: Predicate MIN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1159 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(0, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3673 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 149: /* MaxInstruction: Predicate MAX_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1167 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(
            1, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3683 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 150: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM_A_AO  */
#line 1176 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno));
    }
#line 3693 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 151: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_A VecSrcOperand_G_I_IMM_A_AO  */
#line 1183 "CISA.y"
    {
        pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3703 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 152: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I PredVar  */
#line 1190 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction((yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].vISADecl), CISAlineno));
    }
#line 3711 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 153: /* BreakpointInstruction: BREAKPOINT_OP  */
#line 1196 "CISA.y"
    {
      pBuilder->CISA_create_breakpoint_instruction(CISAlineno);
    }
#line 3719 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 154: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand SrcStateOperand  */
#line 1202 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3728 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 155: /* MovsInstruction: MOVS_OP ExecSize VecDstOperand_G SrcStateOperand  */
#line 1208 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3737 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 156: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand VecSrcOperand_G_I_IMM  */
#line 1214 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3746 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 157: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize PredVar VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1232 "CISA.y"
    {
        pBuilder->CISA_create_cmp_instruction((yyvsp[-4].cond_mod), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3755 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 158: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1239 "CISA.y"
    {
        // NOTE: predication not permitted.  Apparently the vISA API doesn't allow for predicated compares
        pBuilder->CISA_create_cmp_instruction(
            (yyvsp[-4].cond_mod), ISA_CMP, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3766 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 159: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var MediaInstructionPlaneID VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1249 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-7].opcode), (yyvsp[-6].media_mode), (yyvsp[-5].offset).row, (yyvsp[-5].offset).elem, (int)(yyvsp[-3].intval), (yyvsp[-4].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3776 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 160: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1257 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-6].opcode), (yyvsp[-5].media_mode), (yyvsp[-4].offset).row, (yyvsp[-4].offset).elem, (int)0, (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3786 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 161: /* MediaInstructionPlaneID: DEC_LIT  */
#line 1263 "CISA.y"
                                 {
        MUST_HOLD((yyvsp[0].intval) <= 0xF, "PlaneID must less than 0xF");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 3795 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 162: /* ScatterInstruction: SCATTER_OP ElemNum ExecSize OwordModifier Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1271 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_instruction(
            (yyvsp[-7].opcode), (int)(yyvsp[-6].intval), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].oword_mod), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3805 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 163: /* ScatterTypedInstruction: Predicate SCATTER_TYPED_OP SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1280 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_typed_instruction(
            (yyvsp[-8].opcode), (yyvsp[-9].pred_reg), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].string),
            (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3815 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 164: /* Scatter4ScaledInstruction: Predicate SCATTER4_SCALED_OP SAMPLER_CHANNEL ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1289 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_scaled_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-5].s_channel)), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3825 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 165: /* ScatterScaledInstruction: Predicate SCATTER_SCALED_OP DOT DEC_LIT ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1298 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_scaled_instruction(
            (yyvsp[-7].opcode), (yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (uint32_t) (yyvsp[-5].intval), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3835 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 166: /* SynchronizationInstruction: BARRIER_OP  */
#line 1305 "CISA.y"
               {
        pBuilder->CISA_create_sync_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3843 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 167: /* SynchronizationInstruction: SBARRIER_SIGNAL  */
#line 1308 "CISA.y"
                      {
        pBuilder->CISA_create_sbarrier_instruction(true, CISAlineno);
    }
#line 3851 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 168: /* SynchronizationInstruction: SBARRIER_WAIT  */
#line 1311 "CISA.y"
                    {
        pBuilder->CISA_create_sbarrier_instruction(false, CISAlineno);
    }
#line 3859 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 169: /* SynchronizationInstruction: NBARRIER_SIGNAL VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1314 "CISA.y"
                                                                                                              {
        pBuilder->CISA_create_nbarrier_signal((yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3867 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 170: /* SynchronizationInstruction: NBARRIER_SIGNAL VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1317 "CISA.y"
                                                                  {
        pBuilder->CISA_create_nbarrier(false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3875 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 171: /* SynchronizationInstruction: NBARRIER_WAIT VecSrcOperand_G_I_IMM  */
#line 1320 "CISA.y"
                                          {
        pBuilder->CISA_create_nbarrier(true, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3883 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 172: /* DwordAtomicInstruction: Predicate DWORD_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand  */
#line 1326 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_dword_atomic_instruction(
            (yyvsp[-9].pred_reg), (yyvsp[-7].atomic_op), (yyvsp[-6].flag), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3892 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 173: /* TypedAtomicInstruction: Predicate TYPED_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1333 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_typed_atomic_instruction(
            (yyvsp[-12].pred_reg), (yyvsp[-10].atomic_op), (yyvsp[-9].flag), (yyvsp[-8].emask_exec_size).emask, (yyvsp[-8].emask_exec_size).exec_size, (yyvsp[-7].string),
            (yyvsp[-6].RawVar), (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3902 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 174: /* Atomic16Opt: %empty  */
#line 1340 "CISA.y"
             {(yyval.flag) = false;}
#line 3908 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 175: /* Atomic16Opt: DOT DEC_LIT  */
#line 1341 "CISA.y"
                  { // .16
        MUST_HOLD(((yyvsp[0].intval) == 16), "only supports 16");
        (yyval.flag) = true;
    }
#line 3917 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 176: /* SampleUnormInstruction: SAMPLE_UNORM_OP SAMPLER_CHANNEL CHANNEL_OUTPUT Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1348 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sampleunorm_instruction(
            (yyvsp[-9].opcode), ChannelMask::createFromAPI((yyvsp[-8].s_channel)), (yyvsp[-7].s_channel_output), (yyvsp[-6].string), (yyvsp[-5].string),
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3927 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 177: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var Var RawOperand RawOperand RawOperand RawOperand  */
#line 1361 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
            (yyvsp[-8].opcode), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (int)(yyvsp[-6].intval), (yyvsp[-5].string), (yyvsp[-4].string),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3937 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 178: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var RawOperand RawOperand RawOperand RawOperand  */
#line 1369 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
           (yyvsp[-7].opcode), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (int)(yyvsp[-5].intval), "", (yyvsp[-4].string),
           (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3947 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 179: /* SamplerAddrOperand: Var  */
#line 1376 "CISA.y"
                     {
                      (yyval.sampler_base) = {(yyvsp[0].string), (unsigned int)0};
                     }
#line 3955 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 180: /* SamplerAddrOperand: LPAREN Var COMMA IntExpPrim RPAREN  */
#line 1381 "CISA.y"
                     {
                      (yyval.sampler_base) = {(yyvsp[-3].string), (unsigned int)(yyvsp[-1].intval)};
                     }
#line 3963 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 181: /* Sample3dInstruction: Predicate SAMPLE_3D_OP PixelNullMaskEnableOpt CPSEnableOpt NonUniformSamplerEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM SamplerAddrOperand SamplerAddrOperand RawOperand RawOperand RawOperandArray  */
#line 1392 "CISA.y"
   {
       const bool success = pBuilder->create3DSampleInstruction(
           (yyvsp[-12].pred_reg), (yyvsp[-11].sample3DOp), (yyvsp[-10].pixel_null_mask), (yyvsp[-9].cps), (yyvsp[-8].non_uniform_sampler), ChannelMask::createFromAPI((yyvsp[-7].s_channel)),
           (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].sampler_base).base, (yyvsp[-4].sampler_base).offset,
           (yyvsp[-3].sampler_base).base, (yyvsp[-3].sampler_base).offset,
           (yyvsp[-1].RawVar), (yyvsp[-2].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3977 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 182: /* CPSEnableOpt: %empty  */
#line 1402 "CISA.y"
                     {(yyval.cps) = false;}
#line 3983 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 183: /* CPSEnableOpt: CPS  */
#line 1402 "CISA.y"
                                          {(yyval.cps) = true;}
#line 3989 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 184: /* NonUniformSamplerEnableOpt: %empty  */
#line 1404 "CISA.y"
                                   {(yyval.non_uniform_sampler) = false;}
#line 3995 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 185: /* NonUniformSamplerEnableOpt: NON_UNIFORM_SAMPLER  */
#line 1404 "CISA.y"
                                                                       {(yyval.non_uniform_sampler) = true;}
#line 4001 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 186: /* Load3dInstruction: Predicate LOAD_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM SamplerAddrOperand RawOperand RawOperand RawOperandArray  */
#line 1414 "CISA.y"
   {
       const bool success = pBuilder->create3DLoadInstruction(
           (yyvsp[-9].pred_reg), (yyvsp[-8].sample3DOp), (yyvsp[-7].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-6].s_channel)),
           (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].sampler_base).base, (yyvsp[-3].sampler_base).offset,
           (yyvsp[-1].RawVar), (yyvsp[-2].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 4014 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 187: /* Gather43dInstruction: Predicate SAMPLE4_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM SamplerAddrOperand SamplerAddrOperand RawOperand RawOperand RawOperandArray  */
#line 1431 "CISA.y"
   {
       const bool success = pBuilder->createSample4Instruction(
          (yyvsp[-10].pred_reg), (yyvsp[-9].sample3DOp), (yyvsp[-8].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size,
          (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].sampler_base).base, (yyvsp[-4].sampler_base).offset, (yyvsp[-3].sampler_base).base, (yyvsp[-3].sampler_base).offset,
           (yyvsp[-1].RawVar), (yyvsp[-2].RawVar),
          (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 4028 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 188: /* PixelNullMaskEnableOpt: %empty  */
#line 1442 "CISA.y"
                               {(yyval.pixel_null_mask) = false;}
#line 4034 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 189: /* PixelNullMaskEnableOpt: PIXEL_NULL_MASK  */
#line 1442 "CISA.y"
                                                               {(yyval.pixel_null_mask) = true;}
#line 4040 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 190: /* ResInfo3dInstruction: RESINFO_OP_3D SAMPLER_CHANNEL ExecSize SamplerAddrOperand RawOperand RawOperand  */
#line 1446 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_RESINFO, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-4].s_channel)), (yyvsp[-2].sampler_base).base, (yyvsp[-2].sampler_base).offset, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4050 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 191: /* SampleInfo3dInstruction: SAMPLEINFO_OP_3D SAMPLER_CHANNEL ExecSize SamplerAddrOperand RawOperand  */
#line 1454 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_SAMPLEINFO, (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-3].s_channel)), (yyvsp[-1].sampler_base).base, (yyvsp[-1].sampler_base).offset, NULL, (yyvsp[0].RawVar), CISAlineno));
   }
#line 4060 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 192: /* RTWriteOperands: %empty  */
#line 1462 "CISA.y"
    {
    }
#line 4067 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 193: /* RTWriteOperands: RTWriteOperands VecSrcOperand_G_IMM  */
#line 1465 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].genOperand).cisa_gen_opnd);
    }
#line 4075 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 194: /* RTWriteOperands: RTWriteOperands RawOperand  */
#line 1469 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].RawVar));
    }
#line 4083 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 195: /* RTWriteInstruction: Predicate RTWRITE_OP_3D RTWriteModeOpt ExecSize Var RTWriteOperands  */
#line 1477 "CISA.y"
   {
       bool result = pBuilder->CISA_create_rtwrite_3d_instruction(
           (yyvsp[-5].pred_reg), (yyvsp[-3].string), (yyvsp[-2].emask_exec_size).emask, (unsigned int)(yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string),
           RTRWOperandsVec, CISAlineno);
       RTRWOperandsVec.clear();
       if (!result)
           YYABORT; // already reported
   }
#line 4096 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 196: /* RTWriteModeOpt: %empty  */
#line 1487 "CISA.y"
                       {(yyval.string) = 0;}
#line 4102 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 198: /* URBWriteInstruction: Predicate URBWRITE_OP_3D ExecSize DEC_LIT DEC_LIT RawOperand RawOperand RawOperand RawOperand  */
#line 1492 "CISA.y"
    {
        pBuilder->CISA_create_urb_write_3d_instruction(
            (yyvsp[-8].pred_reg), (yyvsp[-6].emask_exec_size).emask, (unsigned int)(yyvsp[-6].emask_exec_size).exec_size, (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-4].intval),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4112 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 199: /* AVSInstruction: AVS_OP SAMPLER_CHANNEL Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM CNTRL VecSrcOperand_G_I_IMM EXECMODE VecSrcOperand_G_I_IMM RawOperand  */
#line 1500 "CISA.y"
    {
        pBuilder->CISA_create_avs_instruction(
            ChannelMask::createFromAPI((yyvsp[-14].s_channel)), (yyvsp[-13].string), (yyvsp[-12].string),
            (yyvsp[-11].genOperand).cisa_gen_opnd, (yyvsp[-10].genOperand).cisa_gen_opnd, (yyvsp[-9].genOperand).cisa_gen_opnd, (yyvsp[-8].genOperand).cisa_gen_opnd,
            (yyvsp[-7].genOperand).cisa_gen_opnd, (yyvsp[-6].genOperand).cisa_gen_opnd, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].cntrl), (yyvsp[-3].genOperand).cisa_gen_opnd,
            (yyvsp[-2].execMode), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4124 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 200: /* VMEInstruction: VME_IME_OP VMEOpndIME Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1512 "CISA.y"
   {
       //     1 - OP
       //     2 - StreamMode, SearchCtrl
       //     3 - Surface
       //     4 - UNIInput
       //     5 - IMEInput
       //     6 - ref0
       //     7 - ref1
       //     8 - CostCenter
       //     9 - Output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_ime_instruction(
            (yyvsp[-8].opcode), (yyvsp[-7].vmeOpndIvb).streamMode, (yyvsp[-7].vmeOpndIvb).searchCtrl, (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-6].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4142 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 201: /* VMEInstruction: VME_SIC_OP Var RawOperand RawOperand RawOperand  */
#line 1528 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_sic_instruction((yyvsp[-4].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4150 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 202: /* VMEInstruction: VME_FBR_OP VMEOpndFBR Var RawOperand RawOperand RawOperand  */
#line 1534 "CISA.y"
   {
        //    1 - OP
        //    2 - FBRMdMode, FBRSubMbShape, FBRSubPredMode
        //    3 - surface
        //    4 - UNIInput
        //    5 - FBRInput
        //    6 - output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_fbr_instruction((yyvsp[-5].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string),
            (yyvsp[-4].vmeOpndFbr).cisa_fbrMbMode_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubMbShape_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubPredMode_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4165 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 203: /* OwordInstruction: OWORD_OP OwordModifier ExecSize Var VecSrcOperand_G_I_IMM RawOperand  */
#line 1547 "CISA.y"
    {
        ABORT_ON_FAIL(
            pBuilder->CISA_create_oword_instruction((yyvsp[-5].opcode), (yyvsp[-4].oword_mod), (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4174 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 204: /* SvmInstruction: SVM_OP SVM_ALIGNED ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1555 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-4].opcode),
(yyvsp[-2].emask_exec_size).exec_size, false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4183 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 205: /* SvmInstruction: SVM_OP SVM_UNALIGNED ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1562 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-4].opcode),
(yyvsp[-2].emask_exec_size).exec_size, true, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4192 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 206: /* SvmInstruction: SVM_OP ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1570 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-3].opcode),
(yyvsp[-2].emask_exec_size).exec_size, true, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4201 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 207: /* SvmInstruction: Predicate SVM_SCATTER_OP DOT DEC_LIT DOT DEC_LIT ExecSize RawOperand RawOperand  */
#line 1576 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter_instruction((yyvsp[-8].pred_reg), (SVMSubOpcode)(yyvsp[-7].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-3].intval), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4210 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 208: /* SvmInstruction: Predicate SVM_ATOMIC_OP ATOMIC_SUB_OP AtomicBitwidthOpt ExecSize RawOperand RawOperand RawOperand RawOperand  */
#line 1582 "CISA.y"
    {
        pBuilder->CISA_create_svm_atomic_instruction((yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-6].atomic_op), (unsigned short)(yyvsp[-5].intval),
            (yyvsp[-3].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), (yyvsp[-2].RawVar), CISAlineno);
    }
#line 4219 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 209: /* SvmInstruction: Predicate SVM_GATHER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1588 "CISA.y"
    {
        pBuilder->CISA_create_svm_gather4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4228 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 210: /* SvmInstruction: Predicate SVM_SCATTER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1594 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4237 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 211: /* AtomicBitwidthOpt: %empty  */
#line 1600 "CISA.y"
             {(yyval.intval) = 32;}
#line 4243 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 212: /* AtomicBitwidthOpt: DOT DEC_LIT  */
#line 1601 "CISA.y"
                  {
        MUST_HOLD((yyvsp[0].intval) == 16 || (yyvsp[0].intval) == 32 || (yyvsp[0].intval) == 64, "only supports 16 or 64");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 4252 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 227: /* LscUntypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand  */
#line 1658 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[0].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0
            nullptr,     // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4277 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 228: /* LscUntypedStridedLoad: Predicate LSC_LOAD_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedStridedAddrOperand  */
#line 1690 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[0].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0 stride
            nullptr,     // src1
            CISAlineno);
    }
#line 4302 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 229: /* LscUntypedBlock2dLoad: Predicate LSC_LOAD_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand2D LscUntypedBlock2dAddrOperand  */
#line 1720 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_data_operand2d).shape2D,  // data shape
            (yyvsp[-1].lsc_data_operand2d).reg,      // dst
            (yyvsp[0].lsc_block2d_addr_operand).regs,     // src0 surface info / addrs
            nullptr,     // src1
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[0],
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[1],
            CISAlineno);
    }
#line 4325 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 230: /* LscUntypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedAddrOperand LscDataOperand  */
#line 1748 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_addr_operand).surfaceIndex, // surface index
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0
            (yyvsp[0].lsc_data_operand).reg,      // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4350 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 231: /* LscUntypedStridedStore: Predicate LSC_STORE_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedStridedAddrOperand LscDataOperand  */
#line 1774 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_addr_operand).surfaceIndex, // surface index
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0 stride
            (yyvsp[0].lsc_data_operand).reg,      // src1
            CISAlineno);
    }
#line 4375 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 232: /* LscUntypedBlock2dStore: Predicate LSC_STORE_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedBlock2dAddrOperand LscDataOperand2D  */
#line 1802 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_data_operand2d).shape2D,  // data2d
            nullptr,     // dst
            (yyvsp[-1].lsc_block2d_addr_operand).regs,     // src0 addrs
            (yyvsp[0].lsc_data_operand2d).reg,      // src1
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[0],
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[1],
            CISAlineno);
    }
#line 4398 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 233: /* LscUntypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1831 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),                // op
            (yyvsp[-6].lsc_sfid),                // sfid
            (yyvsp[-5].lsc_caching_opts),                // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr,         // address info
            (yyvsp[-3].lsc_data_operand).shape,        // data type
            (yyvsp[-2].lsc_addr_operand).surface,      // surface array base
            (yyvsp[-2].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-3].lsc_data_operand).reg,          // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],      // src0 addr
            (yyvsp[-1].RawVar),              // src1 data
            (yyvsp[0].RawVar),              // src2 data (for icas/fcas)
            CISAlineno);
    }
#line 4423 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 234: /* LscTypedMSRTLoad: Predicate LSC_LOAD_MSRT_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperandWithOffsets  */
#line 1857 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_typed_operand).addr.type,     // address model
            (yyvsp[0].lsc_typed_operand).addr.size,     // address size
            (yyvsp[-1].lsc_data_operand).shape,         // data type
            (yyvsp[0].lsc_typed_operand).surface,       // surface array base
            (yyvsp[0].lsc_typed_operand).surfaceIndex,  // surface index
            (yyvsp[-1].lsc_data_operand).reg,           // dst data
            (yyvsp[0].lsc_typed_operand).regs[0],       // src0_u
            (yyvsp[0].lsc_typed_operand).uvrOffsets[0], // src0-u imm offsets
            (yyvsp[0].lsc_typed_operand).regs[1],       // src0_v
            (yyvsp[0].lsc_typed_operand).uvrOffsets[1], // src0-v imm offsets
            (yyvsp[0].lsc_typed_operand).regs[2],       // src0_r
            (yyvsp[0].lsc_typed_operand).uvrOffsets[2], // src0-r imm offsets
            (yyvsp[0].lsc_typed_operand).regs[3],       // sample index
            nullptr,          // src1 data
            nullptr,          // src2 data
            CISAlineno);
    }
#line 4455 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 235: /* LscTypedMSRTStore: Predicate LSC_STORE_MSRT_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscTypedAddrOperandWithOffsets LscDataOperand  */
#line 1890 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_typed_operand).addr.type,     // address model
            (yyvsp[-1].lsc_typed_operand).addr.size,     // address size
            (yyvsp[0].lsc_data_operand).shape,         // data type
            (yyvsp[-1].lsc_typed_operand).surface,       // surface array base
            (yyvsp[-1].lsc_typed_operand).surfaceIndex,  // surface index
            nullptr,          // dst
            (yyvsp[-1].lsc_typed_operand).regs[0],       // src0-u
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[0], // src0-u imm offsets
            (yyvsp[-1].lsc_typed_operand).regs[1],       // src0-v
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[1], // src0-v imm offsets
            (yyvsp[-1].lsc_typed_operand).regs[2],       // src0-r
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[2], // src0-r imm offsets
            (yyvsp[-1].lsc_typed_operand).regs[3],       // src0-sample-index
            (yyvsp[0].lsc_data_operand).reg,           // src1 data
            nullptr,          // src2 data
            CISAlineno);
    }
#line 4487 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 236: /* LscTypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperandWithOffsets  */
#line 1930 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_LOAD_QUAD) {
            PARSE_ERROR("unsupported load operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_typed_operand).addr.type,      // address type
            (yyvsp[0].lsc_typed_operand).addr.size,      // address size
            (yyvsp[-1].lsc_data_operand).shape,          // data
            (yyvsp[0].lsc_typed_operand).surface,        // surface
            (yyvsp[0].lsc_typed_operand).surfaceIndex,   // surface index
            (yyvsp[-1].lsc_data_operand).reg,            // dst
            (yyvsp[0].lsc_typed_operand).regs[0],        // src0_u
            (yyvsp[0].lsc_typed_operand).uvrOffsets[0],  // u offset
            (yyvsp[0].lsc_typed_operand).regs[1],        // src0_v
            (yyvsp[0].lsc_typed_operand).uvrOffsets[1],  // v offset
            (yyvsp[0].lsc_typed_operand).regs[2],        // src0_r
            (yyvsp[0].lsc_typed_operand).uvrOffsets[2],  // r offset
            (yyvsp[0].lsc_typed_operand).regs[3],        // src0_lod
            nullptr,           // src1 data
            nullptr,           // src2 data
            CISAlineno);
    }
#line 4522 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 237: /* LscTypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscTypedAddrOperandWithOffsets LscDataOperand  */
#line 1974 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_STORE_QUAD) {
            PARSE_ERROR("unsupported store operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_typed_operand).addr.type,     // address model
            (yyvsp[-1].lsc_typed_operand).addr.size,     // address size
            (yyvsp[0].lsc_data_operand).shape,         // data size
            (yyvsp[-1].lsc_typed_operand).surface,       // surface
            (yyvsp[-1].lsc_typed_operand).surfaceIndex,  // surface index
            nullptr,          // dst
            (yyvsp[-1].lsc_typed_operand).regs[0],       // src0_u
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[0], // u offset
            (yyvsp[-1].lsc_typed_operand).regs[1],       // src0_v
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[1], // v offset
            (yyvsp[-1].lsc_typed_operand).regs[2],       // src0-r
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[2], // r offset
            (yyvsp[-1].lsc_typed_operand).regs[3],       // src0_lod
            (yyvsp[0].lsc_data_operand).reg,           // stored data
            nullptr,          // src2
            CISAlineno);
    }
#line 4557 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 238: /* LscTypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperandWithOffsets LscPayloadReg LscPayloadReg  */
#line 2019 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),  // subop
            (yyvsp[-6].lsc_sfid),  // sfid
            (yyvsp[-5].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_typed_operand).addr.type, // address model
            (yyvsp[-2].lsc_typed_operand).addr.size,  // address size
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_typed_operand).surface,  // surface
            (yyvsp[-2].lsc_typed_operand).surfaceIndex, // surface index
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_typed_operand).regs[0],  // src0 addrs u
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[0], // u offset
            (yyvsp[-2].lsc_typed_operand).regs[1],  // src0 addrs v
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[1], // v offset
            (yyvsp[-2].lsc_typed_operand).regs[2],  // src0 addrs r
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[2], // r offset
            (yyvsp[-2].lsc_typed_operand).regs[3],  // src0 addrs lod
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data
            CISAlineno);
    }
#line 4589 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 239: /* LscTypedReadStateInfo: Predicate LSC_READ_STATE_INFO_MNEMONIC LSC_SFID_TYPED_TOKEN LscPayloadReg LscAddrModelStateful LBRACK LscPayloadNonNullReg RBRACK  */
#line 2055 "CISA.y"
   {
        LSC_CACHE_OPTS caching {LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};
        LSC_DATA_SHAPE dataShape {LSC_DATA_SIZE_32b,LSC_DATA_ORDER_TRANSPOSE};
        dataShape.elems = LSC_DATA_ELEMS_16;
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-7].pred_reg),              // predicate
            (yyvsp[-6].lsc_subOpcode),              // subop
            (yyvsp[-5].lsc_sfid),              // sfid
            caching,         // no caching settings
            EXEC_SIZE_1,
            vISA_EMASK_M1_NM,
            (yyvsp[-3].lsc_addr_model).type,           // address type
            LSC_ADDR_SIZE_32b, // address size
            dataShape,         // data type
            (yyvsp[-3].lsc_addr_model).surface,        // surface
            (yyvsp[-3].lsc_addr_model).surfaceIndex,   // SS_IDX
            (yyvsp[-4].RawVar),                // dst data
            (yyvsp[-1].RawVar),                // src0 coords (u, v, r, lod) SIMD1 are packed in
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            nullptr,           // no src1 data
            nullptr,           // no src2 data
            CISAlineno);
   }
#line 4622 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 240: /* LscFence: LSC_FENCE_MNEMONIC LscSfid LSC_FENCE_OP_TYPE LSC_FENCE_SCOPE  */
#line 2092 "CISA.y"
    {
        pBuilder->CISA_create_lsc_fence((yyvsp[-2].lsc_sfid), (yyvsp[-1].lsc_fence_op), (yyvsp[0].lsc_scope), CISAlineno);
    }
#line 4630 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 243: /* LscCacheOpts: %empty  */
#line 2099 "CISA.y"
                                    {(yyval.lsc_caching_opts) = pBuilder->CISA_create_caching_opts(CISAlineno);}
#line 4636 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 244: /* LscCacheOpts: LSC_CACHING_OPT LSC_CACHING_OPT  */
#line 2100 "CISA.y"
                                    {(yyval.lsc_caching_opts) = pBuilder->CISA_create_caching_opts((yyvsp[-1].lsc_caching_opt),(yyvsp[0].lsc_caching_opt), CISAlineno);}
#line 4642 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 245: /* LscUntypedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt RBRACK LSC_ADDR_SIZE_TK  */
#line 2107 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface, (yyvsp[-6].lsc_addr_model).surfaceIndex, {(yyvsp[-3].RawVar)}, {(yyvsp[-6].lsc_addr_model).type, (int)(yyvsp[-4].intval), (int)(yyvsp[-2].intval), (yyvsp[0].lsc_addr_size)}};
    }
#line 4650 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 246: /* LscUntypedStridedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt COMMA LscVectorOpRegOrImm32 RBRACK LSC_ADDR_SIZE_TK  */
#line 2116 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface, (yyvsp[-8].lsc_addr_model).surfaceIndex, {(yyvsp[-5].RawVar), (yyvsp[-2].lsc_addr_surface_ident)}, {(yyvsp[-8].lsc_addr_model).type, (int)(yyvsp[-6].intval), (int)(yyvsp[-4].intval), (yyvsp[0].lsc_addr_size)}};
    }
#line 4658 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 247: /* LscUntypedStridedAddrOperand: LscUntypedAddrOperand  */
#line 2119 "CISA.y"
                            {
        (yyval.lsc_addr_operand) = (yyvsp[0].lsc_addr_operand);
        (yyval.lsc_addr_operand).regs[1] = nullptr;
    }
#line 4667 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 248: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpReg LscAddrImmOffsetOpt COMMA LscVectorOpReg LscAddrImmOffsetOpt RBRACK  */
#line 2143 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-13].lsc_addr_surface_ident),(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-2].lsc_addr_surface_ident)},{(int)(yyvsp[-4].intval), (int)(yyvsp[-1].intval)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4675 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 249: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpImm32 COMMA LscVectorOpImm32 RBRACK  */
#line 2163 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-3].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{0, 0},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4683 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 250: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpImm32 COMMA LscVectorOpReg LscAddrImmOffsetOpt RBRACK  */
#line 2183 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-12].lsc_addr_surface_ident),(yyvsp[-10].lsc_addr_surface_ident),(yyvsp[-8].lsc_addr_surface_ident),(yyvsp[-6].lsc_addr_surface_ident),(yyvsp[-4].lsc_addr_surface_ident),(yyvsp[-2].lsc_addr_surface_ident)},{0, (int)(yyvsp[-1].intval)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4691 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 251: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpReg LscAddrImmOffsetOpt COMMA LscVectorOpImm32 RBRACK  */
#line 2203 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-12].lsc_addr_surface_ident),(yyvsp[-10].lsc_addr_surface_ident),(yyvsp[-8].lsc_addr_surface_ident),(yyvsp[-6].lsc_addr_surface_ident),(yyvsp[-4].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{(int)(yyvsp[-3].intval), 0},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4699 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 252: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg PLUS LPAREN IntExpUnr COMMA IntExpUnr RPAREN RBRACK  */
#line 2211 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-7].lsc_addr_surface_ident),nullptr,nullptr,nullptr,nullptr,nullptr},{(int)(yyvsp[-4].intval),(int)(yyvsp[-2].intval)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4707 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 253: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg  */
#line 2216 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[0].RawVar), 0};
    }
#line 4715 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 254: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg PLUS IntExpMul  */
#line 2219 "CISA.y"
                                          {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[-2].RawVar), (int)(yyvsp[0].intval)};
    }
#line 4723 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 255: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg MINUS IntExpMul  */
#line 2223 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[-2].RawVar), (int)-(yyvsp[0].intval)};
    }
#line 4731 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 256: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand  */
#line 2227 "CISA.y"
                                    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[0].lsc_typed_addr_operand).offset, 0, 0}};
      }
#line 4739 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 257: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand  */
#line 2232 "CISA.y"
      {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[-2].lsc_typed_addr_operand).offset, (yyvsp[0].lsc_typed_addr_operand).offset, 0}};
      }
#line 4747 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 258: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand  */
#line 2238 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-4].lsc_typed_addr_operand).reg,(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[-4].lsc_typed_addr_operand).offset, (yyvsp[-2].lsc_typed_addr_operand).offset, (yyvsp[0].lsc_typed_addr_operand).offset}};
    }
#line 4755 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 259: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscPayloadNonNullReg  */
#line 2245 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-6].lsc_typed_addr_operand).reg,(yyvsp[-4].lsc_typed_addr_operand).reg,(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].RawVar)}, {(yyvsp[-6].lsc_typed_addr_operand).offset, (yyvsp[-4].lsc_typed_addr_operand).offset, (yyvsp[-2].lsc_typed_addr_operand).offset}};
    }
#line 4763 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 260: /* LscTypedAddrOperandWithOffsets: LscAddrModelStateful LBRACK LscTypedAddrWithOffsetOperandList RBRACK LSC_ADDR_SIZE_TK  */
#line 2251 "CISA.y"
    {
        (yyval.lsc_typed_operand) = {(yyvsp[-4].lsc_addr_model).surface, (yyvsp[-4].lsc_addr_model).surfaceIndex,
               {(yyvsp[-2].lsc_typed_addr_operand_list).regs[0], (yyvsp[-2].lsc_typed_addr_operand_list).regs[1], (yyvsp[-2].lsc_typed_addr_operand_list).regs[2],(yyvsp[-2].lsc_typed_addr_operand_list).regs[3]},
               {(yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[0], (yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[1], (yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[2]},
               {(yyvsp[-4].lsc_addr_model).type, 1, 0, (yyvsp[0].lsc_addr_size)}};
    }
#line 4774 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 261: /* LscAddrImmOffsetOpt: %empty  */
#line 2262 "CISA.y"
                     {(yyval.intval) =   0;}
#line 4780 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 262: /* LscAddrImmOffsetOpt: PLUS IntExpAdd  */
#line 2263 "CISA.y"
                     {(yyval.intval) =  (yyvsp[0].intval);}
#line 4786 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 263: /* LscAddrImmOffsetOpt: MINUS IntExpMul  */
#line 2264 "CISA.y"
                     {(yyval.intval) = -(yyvsp[0].intval);}
#line 4792 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 264: /* LscAddrImmScaleOpt: %empty  */
#line 2269 "CISA.y"
                     {(yyval.intval) = 1;}
#line 4798 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 265: /* LscAddrImmScaleOpt: IntExpPrim TIMES  */
#line 2270 "CISA.y"
                     {(yyval.intval) = (yyvsp[-1].intval);}
#line 4804 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 266: /* LscAddrModelOpt: %empty  */
#line 2273 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT, nullptr, 0};}
#line 4810 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 267: /* LscAddrModelOpt: LSC_AM_FLAT  */
#line 2274 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT, nullptr, 0};}
#line 4816 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 268: /* LscAddrModelOpt: LSC_AM_ARG  */
#line 2275 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_ARG, nullptr, 0};}
#line 4822 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 270: /* LscAddrModelStateful: LSC_AM_BSS LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2280 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BSS,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4830 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 271: /* LscAddrModelStateful: LSC_AM_BSS LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2283 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BSS, (yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4838 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 272: /* LscAddrModelStateful: LSC_AM_SS LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2286 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_SS,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4846 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 273: /* LscAddrModelStateful: LSC_AM_SS LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2289 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_SS,(yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4854 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 274: /* LscAddrModelStateful: LSC_AM_BTI LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2292 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BTI,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4862 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 275: /* LscAddrModelStateful: LSC_AM_BTI LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2295 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BTI,(yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4870 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 278: /* LscVectorOpImm32: IntExp  */
#line 2304 "CISA.y"
           {
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_immed((yyvsp[0].intval), ISA_TYPE_UD, CISAlineno);
    }
#line 4878 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 279: /* LscVectorOpReg: Var  */
#line 2314 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[0].string),
            0, 1, 0, // region
            0, 0, // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4890 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 280: /* LscVectorOpReg: Var DOT DEC_LIT  */
#line 2322 "CISA.y"
                    {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-2].string),
            0, 1, 0, // region
            0, (unsigned char)(yyvsp[0].intval), // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4902 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 281: /* LscVectorOpReg: Var LPAREN IntExp COMMA IntExp RPAREN  */
#line 2330 "CISA.y"
                                          {
        MUST_HOLD((yyvsp[-3].intval) <= 255 || (yyvsp[-3].intval) >= 0, "row is out of bounds");
        MUST_HOLD((yyvsp[-1].intval) <= 255 || (yyvsp[-1].intval) >= 0, "col is out of bounds");
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-5].string),
            0, 1, 0,
            (unsigned char)(yyvsp[-3].intval), (unsigned char)(yyvsp[-1].intval), // row and col offset
            MODIFIER_NONE, CISAlineno);
        if ((yyval.lsc_addr_surface_ident) == nullptr) {
            PARSE_ERROR("cannot find surface variable");
        }
    }
#line 4919 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 282: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK  */
#line 2344 "CISA.y"
                                     {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4927 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 283: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK_CHMASK  */
#line 2348 "CISA.y"
                                            {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4935 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 284: /* LscDataOperand2D: LscPayloadReg LSC_DATA_SHAPE_TK_BLOCK2D  */
#line 2354 "CISA.y"
                                            {
        (yyval.lsc_data_operand2d) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape2d)};
    }
#line 4943 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 286: /* LscPayloadReg: Var  */
#line 2362 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4951 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 288: /* LscPayloadNonNullReg: VarNonNull  */
#line 2369 "CISA.y"
               {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4959 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 292: /* LscTypedBlock2dLoad: Predicate LSC_LOAD_BLOCK2D_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts LscDataOperandTyped2D LscTypedBlock2dAddrOperand  */
#line 2393 "CISA.y"
    {
        pBuilder->CISA_create_lsc_typed_block2d_inst(
            (yyvsp[-4].lsc_subOpcode),  // subop
            (yyvsp[-2].lsc_caching_opts),  // caching settings
            (yyvsp[0].lsc_block2d_addr_operand).addr.type, // address model
            (yyvsp[-1].lsc_data_operand_typed2d).shape_typed2d,  // data shape
            (yyvsp[0].lsc_block2d_addr_operand).surface,  //surface
            (yyvsp[0].lsc_block2d_addr_operand).surfaceIndex, // surface index
            (yyvsp[-1].lsc_data_operand_typed2d).reg,      // dst
            (yyvsp[0].lsc_block2d_addr_operand).regs[0],     // src0 addrs(block start offset x)
            (yyvsp[0].lsc_block2d_addr_operand).regs[1],     // src0 addrs(block start offset y)
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[0], // x immediate offset
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[1], // y immediate offset
            nullptr,     // src1
            CISAlineno);
   }
#line 4980 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 293: /* LscTypedBlock2dStore: Predicate LSC_STORE_BLOCK2D_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts LscTypedBlock2dAddrOperand LscDataOperandTyped2D  */
#line 2422 "CISA.y"
    {
        pBuilder->CISA_create_lsc_typed_block2d_inst(
            (yyvsp[-4].lsc_subOpcode),  // subop
            (yyvsp[-2].lsc_caching_opts),  // caching settings
            (yyvsp[-1].lsc_block2d_addr_operand).addr.type, // address model
            (yyvsp[0].lsc_data_operand_typed2d).shape_typed2d,  // data shape
            (yyvsp[-1].lsc_block2d_addr_operand).surface,  //surface
            (yyvsp[-1].lsc_block2d_addr_operand).surfaceIndex,
            nullptr,     // dst
            (yyvsp[-1].lsc_block2d_addr_operand).regs[0],     // src0 addrs(block start offset x)
            (yyvsp[-1].lsc_block2d_addr_operand).regs[1],     // src0 addrs(block start offset y)
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[0], // x immediate offset
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[1], // y immediate offset
            (yyvsp[0].lsc_data_operand_typed2d).reg,      // src1
            CISAlineno);
    }
#line 5001 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 294: /* LscTypedBlock2dAddrOperand: LscAddrModelStateful LBRACK LscVectorOpImm32 COMMA LscVectorOpImm32 RBRACK  */
#line 2448 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {(yyvsp[-5].lsc_addr_model).surface, 0, {(yyvsp[-3].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{0,0},{(yyvsp[-5].lsc_addr_model).type,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 5009 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 295: /* LscTypedBlock2dAddrOperand: LscAddrModelStateful LBRACK LscVectorOpReg LscAddrImmOffsetOpt COMMA LscVectorOpReg LscAddrImmOffsetOpt RBRACK  */
#line 2458 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {(yyvsp[-7].lsc_addr_model).surface, (yyvsp[-7].lsc_addr_model).surfaceIndex, {(yyvsp[-5].lsc_addr_surface_ident), (yyvsp[-2].lsc_addr_surface_ident)}, {(int)(yyvsp[-4].intval), (int)(yyvsp[-1].intval)}, {(yyvsp[-7].lsc_addr_model).type, 1, 0, LSC_ADDR_SIZE_64b}};
    }
#line 5017 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 296: /* LscDataOperandTyped2D: LscPayloadReg LSC_DATA_SHAPE_TK_TYPED_BLOCK2D  */
#line 2464 "CISA.y"
                                                  {
        (yyval.lsc_data_operand_typed2d) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape_typed2d)};
    }
#line 5025 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 297: /* LscUntypedApndCtrAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscAddrModelStateful LscDataOperand  */
#line 2476 "CISA.y"
    {
        (yyvsp[-3].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-5].lsc_sfid), (yyvsp[-6].lsc_subOpcode), (yyvsp[-2].lsc_data_operand).shape.order, (yyvsp[-3].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_append_counter_atomic_inst(
            (yyvsp[-6].lsc_subOpcode),          // op
            (yyvsp[-7].pred_reg),          // predicate
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-3].emask_exec_size).exec_size),
            (yyvsp[-3].emask_exec_size).emask,    // execution mask
            (yyvsp[-4].lsc_caching_opts),          // caching settings
            (yyvsp[-1].lsc_addr_model).type,     // address type
            (yyvsp[-2].lsc_data_operand).shape,    // data shape
            (yyvsp[-1].lsc_addr_model).surface,  // surface
            (yyvsp[-1].lsc_addr_model).surfaceIndex,
            (yyvsp[-2].lsc_data_operand).reg,      // dst data
            (yyvsp[0].lsc_data_operand).reg,      // src1 data
            CISAlineno);
    }
#line 5047 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 298: /* SwitchLabels: %empty  */
#line 2496 "CISA.y"
    {
    }
#line 5054 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 299: /* SwitchLabels: COMMA SwitchLabels  */
#line 2499 "CISA.y"
    {
    }
#line 5061 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 300: /* SwitchLabels: IDENT SwitchLabels  */
#line 2502 "CISA.y"
    {
        // parse rule means we see last label first
        switchLabels.push_front((yyvsp[-1].string));
    }
#line 5070 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 301: /* BranchInstruction: Predicate BRANCH_OP ExecSize IdentOrStringLit  */
#line 2509 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].opcode), (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), false, CISAlineno);
    }
#line 5078 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 302: /* BranchInstruction: Predicate CALL_OP ExecSize IdentOrStringLit  */
#line 2513 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].cisa_call).opcode, (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), (yyvsp[-2].cisa_call).is_fccall, CISAlineno);
    }
#line 5086 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 303: /* BranchInstruction: Predicate RET_OP ExecSize  */
#line 2517 "CISA.y"
    {
        pBuilder->CISA_Create_Ret((yyvsp[-2].pred_reg), (yyvsp[-1].opcode), (yyvsp[0].emask_exec_size).emask, (yyvsp[0].emask_exec_size).exec_size, CISAlineno);
    }
#line 5094 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 304: /* BranchInstruction: SWITCHJMP_OP ExecSize VecSrcOperand_G_I_IMM LPAREN SwitchLabels RPAREN  */
#line 2521 "CISA.y"
    {
        pBuilder->CISA_create_switch_instruction((yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, switchLabels, CISAlineno);
        switchLabels.clear();
    }
#line 5103 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 305: /* BranchInstruction: Predicate FCALL ExecSize IDENT DEC_LIT DEC_LIT  */
#line 2527 "CISA.y"
    {
        pBuilder->CISA_create_fcall_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 5111 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 306: /* BranchInstruction: Predicate IFCALL ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2532 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-5].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, false,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 5121 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 307: /* BranchInstruction: Predicate IFCALL UNIFORM ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2539 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, true,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 5131 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 308: /* BranchInstruction: FADDR IdentOrStringLit VecDstOperand_G_I  */
#line 2546 "CISA.y"
    {
        pBuilder->CISA_create_faddr_instruction((yyvsp[-1].string), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 5139 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 309: /* FILE: FILE_OP STRING_LIT  */
#line 2551 "CISA.y"
    {
        pBuilder->CISA_create_FILE_instruction((yyvsp[-1].opcode), (yyvsp[0].string), CISAlineno);
    }
#line 5147 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 310: /* LOC: LOC_OP DEC_LIT  */
#line 2556 "CISA.y"
    {
        pBuilder->CISA_create_LOC_instruction((yyvsp[-1].opcode), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 5155 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 311: /* RawSendInstruction: Predicate RAW_SEND_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2562 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, false, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5164 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 312: /* RawSendInstruction: Predicate RAW_SENDC_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2569 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, true, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5173 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 313: /* LifetimeStartInst: LIFETIME_START_OP IDENT  */
#line 2576 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)0, (yyvsp[0].string), CISAlineno));
    }
#line 5181 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 314: /* LifetimeEndInst: LIFETIME_END_OP IDENT  */
#line 2582 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)1, (yyvsp[0].string), CISAlineno));
    }
#line 5189 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 315: /* RawSendsInstruction: Predicate RAW_SENDS_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2588 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5200 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 316: /* RawSendsInstruction: Predicate RAW_SENDS_EOT_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2596 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5211 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 317: /* RawSendsInstruction: Predicate RAW_SENDSC_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2604 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5222 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 318: /* RawSendsInstruction: Predicate RAW_SENDSC_EOT_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2612 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5233 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 319: /* NullaryInstruction: CACHE_FLUSH_OP  */
#line 2622 "CISA.y"
    {
        pBuilder->CISA_create_NO_OPND_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 5241 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 320: /* NullaryInstruction: WAIT_OP VecSrcOperand_G_IMM  */
#line 2627 "CISA.y"
    {
        pBuilder->CISA_create_wait_instruction((yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 5249 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 321: /* NullaryInstruction: YIELD_OP  */
#line 2632 "CISA.y"
    {
        pBuilder->CISA_create_yield_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 5257 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 322: /* NullaryInstruction: FENCE_GLOBAL_OP  */
#line 2637 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x0, CISAlineno);
    }
#line 5265 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 323: /* NullaryInstruction: FENCE_GLOBAL_OP FENCE_OPTIONS  */
#line 2642 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options), CISAlineno);
    }
#line 5273 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 324: /* NullaryInstruction: FENCE_LOCAL_OP  */
#line 2647 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x20, CISAlineno);
    }
#line 5281 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 325: /* NullaryInstruction: FENCE_LOCAL_OP FENCE_OPTIONS  */
#line 2652 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options) | 0x20, CISAlineno);
    }
#line 5289 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 326: /* NullaryInstruction: FENCE_SW_OP  */
#line 2657 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x80, CISAlineno);
    }
#line 5297 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 327: /* OwordModifier: %empty  */
#line 2661 "CISA.y"
                      {(yyval.oword_mod) = false;}
#line 5303 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 329: /* Predicate: %empty  */
#line 2668 "CISA.y"
    {
        (yyval.pred_reg) = NULL;
    }
#line 5311 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 330: /* Predicate: LPAREN PredSign PredVar PredCtrlOpt RPAREN  */
#line 2673 "CISA.y"
    {
        (yyval.pred_reg) = pBuilder->CISA_create_predicate_operand((yyvsp[-2].vISADecl), (yyvsp[-3].pred_sign), (yyvsp[-1].pred_ctrl), CISAlineno);
    }
#line 5319 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 331: /* PredSign: %empty  */
#line 2677 "CISA.y"
                 {(yyval.pred_sign) = PredState_NO_INVERSE;}
#line 5325 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 332: /* PredSign: BANG  */
#line 2677 "CISA.y"
                                                     {(yyval.pred_sign) = PredState_INVERSE;}
#line 5331 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 333: /* PredCtrlOpt: %empty  */
#line 2679 "CISA.y"
                    {(yyval.pred_ctrl) = PRED_CTRL_NON;}
#line 5337 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 335: /* SatModOpt: %empty  */
#line 2682 "CISA.y"
                  {(yyval.sat) = false;}
#line 5343 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 336: /* SatModOpt: SAT  */
#line 2682 "CISA.y"
                                      {(yyval.sat) = true;}
#line 5349 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 337: /* SrcModifier: SRCMOD_NEG  */
#line 2685 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG;}
#line 5355 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 338: /* SrcModifier: SRCMOD_ABS  */
#line 2686 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_ABS;}
#line 5361 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 339: /* SrcModifier: SRCMOD_NEGABS  */
#line 2687 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG_ABS;}
#line 5367 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 340: /* SrcModifier: SRCMOD_NOT  */
#line 2688 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NOT;}
#line 5373 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 341: /* ConditionalModifier: %empty  */
#line 2690 "CISA.y"
                            {(yyval.cond_mod) = ISA_CMP_UNDEF;}
#line 5379 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 343: /* VecDstOperand_A: DstAddrOperand  */
#line 2695 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5385 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 344: /* VecDstOperand_G: DstGeneralOperand  */
#line 2696 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5391 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 345: /* VecDstOperand_G_I: DstGeneralOperand  */
#line 2698 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5397 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 346: /* VecDstOperand_G_I: DstIndirectOperand  */
#line 2699 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 5403 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 348: /* VecSrcOperand_G_I_IMM_A_AO: SrcAddrOfOperand  */
#line 2704 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5409 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 350: /* VecSrcOperand_G_I_IMM_A: SrcAddrOperand  */
#line 2708 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5415 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 352: /* VecSrcOperand_G_I_IMM: SrcIndirectOperand  */
#line 2712 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 5421 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 353: /* VecSrcOperand_G_I_IMM: SrcImmOperand  */
#line 2713 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5427 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 355: /* VecSrcOperand_G_IMM: SrcImmOperand  */
#line 2717 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5433 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 357: /* VecSrcOperand_G_IMM_AO: SrcImmOperand  */
#line 2721 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5439 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 358: /* VecSrcOperand_G_IMM_AO: SrcAddrOfOperand  */
#line 2722 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5445 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 360: /* VecSrcOperand_G_A: SrcAddrOperand  */
#line 2726 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5451 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 362: /* VecSrcOperand_G_A_AO: SrcAddrOfOperand  */
#line 2730 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5457 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 363: /* VecSrcOperand_G: SrcGeneralOperand  */
#line 2732 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5463 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 364: /* VecSrcOpndSimple: Var TwoDimOffset  */
#line 2735 "CISA.y"
    {
        // simple vector operand with no modifier that has an
        // implicit src region = <1,1,0>
        (yyval.genOperand).type = OPERAND_GENERAL;
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-1].string), 1, 1, 0, (yyvsp[0].offset).row, (yyvsp[0].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5475 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 365: /* VMEOpndIME: LPAREN DEC_LIT COMMA DEC_LIT RPAREN  */
#line 2745 "CISA.y"
    {
        (yyval.vmeOpndIvb).streamMode = (unsigned char)(yyvsp[-3].intval);
        (yyval.vmeOpndIvb).searchCtrl = (unsigned char)(yyvsp[-1].intval);
    }
#line 5484 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 366: /* VMEOpndFBR: LPAREN VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM RPAREN  */
#line 2752 "CISA.y"
    {
        (yyval.vmeOpndFbr).cisa_fbrMbMode_opnd = (yyvsp[-5].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubMbShape_opnd = (yyvsp[-3].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubPredMode_opnd = (yyvsp[-1].genOperand).cisa_gen_opnd;
    }
#line 5494 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 367: /* SrcStateOperand: Var LPAREN IntExp RPAREN  */
#line 2760 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, false));
    }
#line 5504 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 368: /* DstStateOperand: Var LPAREN IntExp RPAREN  */
#line 2768 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, true));
    }
#line 5514 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 370: /* RawOperand: BUILTIN_NULL DOT DEC_LIT  */
#line 2799 "CISA.y"
    {
        MUST_HOLD((yyvsp[0].intval) == 0, "%null must have 0 as offset");
        (yyval.RawVar) = pBuilder->CISA_create_RAW_NULL_operand(CISAlineno); // can't fail
    }
#line 5523 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 371: /* RawOperandNonNull: VarNonNull RawOperandOffsetSuffix  */
#line 2806 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[-1].string), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5531 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 372: /* RawOperandOffsetSuffix: DOT DEC_LIT  */
#line 2817 "CISA.y"
                {
        MUST_HOLD((yyvsp[0].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5540 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 373: /* RawOperandOffsetSuffix: DOT LPAREN IntExp RPAREN  */
#line 2822 "CISA.y"
                             {
        MUST_HOLD((yyvsp[-1].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5549 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 374: /* RawOperandArray: %empty  */
#line 2830 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 5557 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 375: /* RawOperandArray: RawOperandArray RawOperand  */
#line 2835 "CISA.y"
    {
        rawOperandArray[(yyvsp[-1].intval)++] = (VISA_RawOpnd*)(yyvsp[0].RawVar);
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5566 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 376: /* DstAddrOperand: AddrVarAccessWithWidth  */
#line 2843 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
          pBuilder->CISA_set_address_operand(
            (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, true, CISAlineno));
    }
#line 5576 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 377: /* DstGeneralOperand: Var TwoDimOffset DstRegion  */
#line 2851 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-2].string), (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5585 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 378: /* DstGeneralOperand: Var DstRegion  */
#line 2856 "CISA.y"
                  {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-1].string), 0, 0, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5594 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 379: /* DstIndirectOperand: IndirectVarAccess DstRegion DataType  */
#line 2862 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_indirect_dst(
            (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (unsigned short)(yyvsp[-1].intval), (yyvsp[0].type), CISAlineno));
    }
#line 5603 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 380: /* SrcAddrOfOperand: AddrOfVar  */
#line 2883 "CISA.y"
              {
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[0].regAccess).cisa_decl, 0, CISAlineno);
    }
#line 5611 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 381: /* SrcAddrOfOperand: AddrOfVar LBRACK IntExp RBRACK  */
#line 2887 "CISA.y"
                                   {
         MUST_HOLD((short)(yyvsp[-1].intval) == (yyvsp[-1].intval), "variable address offset is too large");
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[-3].regAccess).cisa_decl, (short)(yyvsp[-1].intval), CISAlineno);
    }
#line 5620 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 382: /* AddrOfVar: AMP Var  */
#line 2893 "CISA.y"
            {
        // Both GENERAL_VAR and SURFACE_VAR are addressable
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.regAccess).cisa_decl == nullptr)
            PARSE_ERROR("unbound variable");
        (yyval.regAccess).row = 0;
        (yyval.regAccess).elem = 0;
    }
#line 5633 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 383: /* SrcAddrOperand: AddrVarAccessWithWidth  */
#line 2904 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_set_address_operand(
                (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, false, CISAlineno));
    }
#line 5643 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 384: /* SrcGeneralOperand: Var TwoDimOffset SrcRegionDirect  */
#line 2912 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5653 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 385: /* SrcGeneralOperand: SrcModifier Var TwoDimOffset SrcRegionDirect  */
#line 2919 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (yyvsp[-3].src_mod).mod, CISAlineno));
    }
#line 5663 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 386: /* SrcImmOperand: IntExpUnr DataTypeIntOrVector  */
#line 2929 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed((yyvsp[-1].intval), (yyvsp[0].type), CISAlineno);
    }
#line 5671 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 387: /* SrcImmOperand: HEX_LIT HFTYPE  */
#line 2934 "CISA.y"
                     {
        MUST_HOLD((yyvsp[-1].intval) < 0x10000, "literal too large for half float");
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed(
            (unsigned short)(yyvsp[-1].intval), ISA_TYPE_HF, CISAlineno);
    }
#line 5681 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 388: /* SrcImmOperand: FloatLit  */
#line 2942 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5689 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 389: /* SrcImmOperand: MINUS FloatLit  */
#line 2945 "CISA.y"
                     {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5697 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 390: /* SrcImmOperand: DoubleFloatLit  */
#line 2951 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5705 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 391: /* SrcImmOperand: MINUS DoubleFloatLit  */
#line 2955 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5713 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 393: /* FloatLit: DEC_LIT FTYPE  */
#line 2962 "CISA.y"
   {
        // "1:f" means 1.4e-45
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5724 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 394: /* FloatLit: HEX_LIT FTYPE  */
#line 2969 "CISA.y"
   {
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5734 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 396: /* DoubleFloatLit: DEC_LIT DFTYPE  */
#line 2977 "CISA.y"
                    {
        // "1:df" means 5e-324
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5745 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 397: /* DoubleFloatLit: HEX_LIT DFTYPE  */
#line 2983 "CISA.y"
                    {
        // to support 0x7ff0000000000000:df
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5756 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 398: /* SrcIndirectOperand: IndirectVarAccess SrcRegionIndirect DataType  */
#line 2994 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5767 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 399: /* SrcIndirectOperand: SrcModifier IndirectVarAccess SrcRegionIndirect DataType  */
#line 3002 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, (yyvsp[-3].src_mod).mod, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5778 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 400: /* DstRegion: LANGLE IntExpNRA RANGLE  */
#line 3011 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "Dst HorzStride must be 0, 1, 2, or 4");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5788 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 401: /* SrcRegionDirect: LANGLE IntExp SEMI IntExp COMMA IntExpNRA RANGLE  */
#line 3029 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-5].intval) == 0 || (yyvsp[-5].intval) == 1 || (yyvsp[-5].intval) == 2 || (yyvsp[-5].intval) == 4 || (yyvsp[-5].intval) == 8 || (yyvsp[-5].intval) == 16 || (yyvsp[-5].intval) == 32),
                 "Src Region VertStride must be 0, 1, 2, 4, 8, 16, or 32");
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Src Region Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "Src Region HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = (unsigned)(yyvsp[-5].intval);
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5804 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 403: /* SrcRegionIndirect: LANGLE IntExp COMMA DEC_LIT RANGLE  */
#line 3046 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5818 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 404: /* SrcRegionIndirect: LANGLE IntExpNRA RANGLE  */
#line 3057 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = -1;
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5830 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 405: /* IndirectVarAccess: IND_LBRACK AddrVarAccess COMMA IntExp RBRACK  */
#line 3067 "CISA.y"
                                                 {
        (yyval.regAccess) = (yyvsp[-3].regAccess);
        (yyval.regAccess).immOff = (int)(yyvsp[-1].intval);
    }
#line 5839 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 406: /* IndirectVarAccess: IND_LBRACK AddrVarAccess RBRACK  */
#line 3072 "CISA.y"
                                                 {
          (yyval.regAccess) = (yyvsp[-1].regAccess);
          (yyval.regAccess).immOff = 0;
    }
#line 5848 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 407: /* TwoDimOffset: LPAREN IntExp COMMA IntExp RPAREN  */
#line 3077 "CISA.y"
                                                {
        MUST_HOLD((yyvsp[-3].intval) >= 0, "row (register) offset must be positive");
        (yyval.offset).row = (int)(yyvsp[-3].intval);
        MUST_HOLD((yyvsp[-1].intval) >= 0 && (yyvsp[-1].intval) <= 0xFFFF, "sub-register offset out of bounds");
        (yyval.offset).elem = (int)(yyvsp[-1].intval);
    }
#line 5859 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 408: /* PredVar: Var  */
#line 3085 "CISA.y"
        {
        (yyval.vISADecl) = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.vISADecl) == nullptr)
            PARSE_ERROR((yyvsp[0].string), ": undefined predicate variable");
        if ((yyval.vISADecl)->type != PREDICATE_VAR)
            PARSE_ERROR((yyvsp[0].string), ": not a predicate variable");
    }
#line 5871 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 409: /* AddrVarAccess: Var LPAREN IntExp RPAREN  */
#line 3094 "CISA.y"
                             {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-3].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-3].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-3].string), ": not an address variable");
        }
        (yyval.regAccess).row = 1;
        (yyval.regAccess).elem = (int)(yyvsp[-1].intval);
    }
#line 5886 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 410: /* AddrVarAccessWithWidth: Var LPAREN IntExp RPAREN LANGLE IntExpNRA RANGLE  */
#line 3106 "CISA.y"
                                                     {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-6].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-6].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-6].string), ": not an address variable");
        }
        (yyval.regAccess).row = (int)(yyvsp[-1].intval);
        (yyval.regAccess).elem = (int)(yyvsp[-4].intval);
    }
#line 5901 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 411: /* SIMDMode: %empty  */
#line 3120 "CISA.y"
           {(yyval.intval) = 0;}
#line 5907 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 412: /* SIMDMode: LPAREN DEC_LIT RPAREN  */
#line 3123 "CISA.y"
    {
       MUST_HOLD(((yyvsp[-1].intval) == 8 || (yyvsp[-1].intval) == 16 || (yyvsp[-1].intval) == 32),
                 "SIMD mode can only be 8, 16, or 32");
       (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5917 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 413: /* ElemNum: DOT DEC_LIT  */
#line 3134 "CISA.y"
    {
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5925 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 414: /* ExecSize: LPAREN ExecSizeInt RPAREN  */
#line 3146 "CISA.y"
    {
        (yyval.emask_exec_size).emask = vISA_EMASK_M1;
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5934 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 415: /* ExecSize: LPAREN Var COMMA ExecSizeInt RPAREN  */
#line 3152 "CISA.y"
    {
        if (!ParseEMask((yyvsp[-3].string), (yyval.emask_exec_size).emask)) {
            PARSE_ERROR("invalid execution offset info");
        }
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5945 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 416: /* ExecSizeInt: DEC_LIT  */
#line 3160 "CISA.y"
    {
        if ((yyvsp[0].intval) != 1 && (yyvsp[0].intval) != 2 && (yyvsp[0].intval) != 4 && (yyvsp[0].intval) != 8 && (yyvsp[0].intval) != 16 && (yyvsp[0].intval) != 32) {
            PARSE_ERROR("invalid execution size");
        }
        (yyval.intval) = (unsigned short)(yyvsp[0].intval);
    }
#line 5956 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 422: /* IntExpCond: IntExpAND QUESTION IntExpAND COLON IntExpCond  */
#line 3174 "CISA.y"
                                                    {(yyval.intval) = (yyvsp[-4].intval) ? (yyvsp[-2].intval) : (yyvsp[0].intval);}
#line 5962 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 424: /* IntExpAND: IntExpAND AMP IntExpXOR  */
#line 3177 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) & (yyvsp[0].intval);}
#line 5968 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 426: /* IntExpXOR: IntExpXOR CIRC IntExpOR  */
#line 3180 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) ^ (yyvsp[0].intval);}
#line 5974 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 428: /* IntExpOR: IntExpOR PIPE IntExpCmp  */
#line 3183 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval);}
#line 5980 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 430: /* IntExpCmp: IntExpRel EQ IntExpRel  */
#line 3186 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) == (yyvsp[0].intval);}
#line 5986 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 431: /* IntExpCmp: IntExpRel NEQ IntExpRel  */
#line 3187 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) != (yyvsp[0].intval);}
#line 5992 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 433: /* IntExpRel: IntExpNRA LANGLE IntExpNRA  */
#line 3190 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) < (yyvsp[0].intval);}
#line 5998 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 434: /* IntExpRel: IntExpNRA RANGLE IntExpNRA  */
#line 3191 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) > (yyvsp[0].intval);}
#line 6004 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 435: /* IntExpRel: IntExpNRA LEQ IntExpNRA  */
#line 3192 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) <= (yyvsp[0].intval);}
#line 6010 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 436: /* IntExpRel: IntExpNRA GEQ IntExpNRA  */
#line 3193 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) >= (yyvsp[0].intval);}
#line 6016 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 439: /* IntExpShift: IntExpAdd SHL IntExpAdd  */
#line 3216 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) << (yyvsp[0].intval);}
#line 6022 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 440: /* IntExpShift: IntExpAdd SHRS IntExpAdd  */
#line 3217 "CISA.y"
                               {(yyval.intval) = (int64_t)(yyvsp[-2].intval) >> (int)(yyvsp[0].intval);}
#line 6028 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 441: /* IntExpShift: IntExpAdd SHRZ IntExpAdd  */
#line 3218 "CISA.y"
                               {(yyval.intval) = (int64_t)((uint64_t)(yyvsp[-2].intval) >> (uint64_t)(yyvsp[0].intval));}
#line 6034 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 443: /* IntExpAdd: IntExpAdd PLUS IntExpMul  */
#line 3221 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) + (yyvsp[0].intval);}
#line 6040 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 444: /* IntExpAdd: IntExpAdd MINUS IntExpMul  */
#line 3222 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) - (yyvsp[0].intval);}
#line 6046 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 446: /* IntExpMul: IntExpMul TIMES IntExpUnr  */
#line 3225 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) * (yyvsp[0].intval);}
#line 6052 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 447: /* IntExpMul: IntExpMul SLASH IntExpUnr  */
#line 3226 "CISA.y"
                                {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) / (yyvsp[0].intval);
        }
#line 6062 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 448: /* IntExpMul: IntExpMul PERCENT IntExpUnr  */
#line 3231 "CISA.y"
                                  {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) % (yyvsp[0].intval);
        }
#line 6072 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 450: /* IntExpUnr: MINUS IntExpUnr  */
#line 3238 "CISA.y"
                      {(yyval.intval) = -(yyvsp[0].intval);}
#line 6078 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 451: /* IntExpUnr: TILDE IntExpUnr  */
#line 3239 "CISA.y"
                      {(yyval.intval) = ~(yyvsp[0].intval);}
#line 6084 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 452: /* IntExpUnr: BANG IntExpUnr  */
#line 3240 "CISA.y"
                      {(yyval.intval) = !((yyvsp[0].intval));}
#line 6090 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 456: /* IntExpPrim: LPAREN IntExp RPAREN  */
#line 3248 "CISA.y"
                           {(yyval.intval) = (yyvsp[-1].intval);}
#line 6096 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 457: /* IntExpPrim: BUILTIN_SIZEOF IDENT  */
#line 3252 "CISA.y"
                           {
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[0].string), (yyval.intval)));
    }
#line 6105 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 458: /* IntExpPrim: BUILTIN_SIZEOF LPAREN IDENT RPAREN  */
#line 3256 "CISA.y"
                                         {
        // TODO: %AlignOf(...), %Max(..)
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), (yyval.intval)));
    }
#line 6115 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 459: /* IntExpPrim: BUILTIN_DISPATCH_SIMD_SIZE  */
#line 3262 "CISA.y"
                                 {
        // e.g. %DispatchSimdSize
        // N.B. %sizeof happens above
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_lookup_builtin_constant(CISAlineno, "%DispatchSimd", (yyval.intval)));
    }
#line 6126 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 467: /* BuildOptions: BUILD_OPTION_LINE  */
#line 3282 "CISA.y"
    {
        pBuilder->CISA_parse_build_options((yyvsp[0].string));
    }
#line 6134 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;


#line 6138 "/builddir/build/BUILD/intel-igc-2.11.9-build/intel-graphics-compiler-2.11.9/redhat-linux-build/IGC/visa/CISA.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (pBuilder, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pBuilder);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, pBuilder);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (pBuilder, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pBuilder);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, pBuilder);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 3287 "CISA.y"

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                        Utility Functions                                  //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

void CISAerror(CISA_IR_Builder* pBuilder, char const *s)
{
    pBuilder->RecordParseError(CISAlineno, s);
}

static bool streq(const char *sym0, const char *sym1)
{
  return strcmp(sym0, sym1) == 0;
}

static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value)
{
    if (strcmp(sym, "byte") == 0) {
        value = ALIGN_BYTE;
    } else if (strcmp(sym, "word") == 0) {
        value = ALIGN_WORD;
    } else if (strcmp(sym, "dword") == 0) {
        value = ALIGN_DWORD;
    } else if (strcmp(sym, "qword") == 0) {
        value = ALIGN_QWORD;
    } else if (strcmp(sym, "oword") == 0) {
        value = ALIGN_OWORD;
    } else if (strcmp(sym, "GRF") == 0) {
        value = ALIGN_GRF;
    } else if (strcmp(sym, "GRFx2") == 0 || strcmp(sym, "2GRF") == 0) {
        value = ALIGN_2_GRF;
    } else if (strcmp(sym, "hword") == 0) {
        value = ALIGN_HWORD;
    } else if (strcmp(sym, "wordx32") == 0) {
        value = ALIGN_32WORD;
    } else if (strcmp(sym, "wordx64") == 0) {
        value = ALIGN_64WORD;
    } else {
        value = ALIGN_UNDEF;
        return false;
    }
    return true;
}


static VISA_Align AlignBytesToVisaAlignment(int bytes)
{
    VISA_Align val = ALIGN_UNDEF;
    switch (bytes) {
    case 1:   val = ALIGN_BYTE; break;
    case 2:   val = ALIGN_WORD; break;
    case 4:   val = ALIGN_DWORD; break;
    case 8:   val = ALIGN_QWORD; break;
    case 16:  val = ALIGN_OWORD; break;
    case 32:  val = ALIGN_HWORD; break;
    case 64:  val = ALIGN_32WORD; break;
    case 128: val = ALIGN_64WORD; break;
    default:  val = ALIGN_UNDEF; break;
    }
    return val;
}



static bool ParseEMask(
    const char* sym,
    VISA_EMask_Ctrl &emask)
{
    if (strcmp(sym, "NoMask") == 0) {
        emask = vISA_EMASK_M1_NM;
        return true;
    }
    for (int i = 0; i < vISA_NUM_EMASK +1; i++)
    {
        if (!strcmp(emask_str[i], sym))
        {
            emask = (VISA_EMask_Ctrl)i;
            return true;
        }
    }

    emask = vISA_NUM_EMASK;
    return false;
}

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size)
{
    int is_vector_op =
        op != LSC_LOAD_BLOCK2D &&
        op != LSC_STORE_BLOCK2D;
        // other ops like LSC_LOAD_SURFACE_INFO may be SIMD1
    if (op == LSC_READ_STATE_INFO) {
        exec_size = 1;
    } else if (data_order == LSC_DATA_ORDER_NONTRANSPOSE && is_vector_op) {
        if (exec_size == UNDEFINED_EXEC_SIZE) {
            if (pBuilder->getPlatform() == Xe_DG2) // for DG2 typed is 8, untyped is 16
                exec_size = sfid == LSC_TGM ? 8 : 16;
            else if (pBuilder->getPlatform() >= Xe_PVC) // on PVC typed is 16, untyped is 32
                exec_size = sfid == LSC_TGM ? 16 : 32;
            else
                exec_size = 32; // the world is finally sane
        }
    } else {
        // block and transpose get SIMD by default
        if (exec_size == UNDEFINED_EXEC_SIZE) {
           exec_size = 1; // transpose is implicitly 1 if needed
        }
    }
    return exec_size;
}
